/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/AmpEditor.ts":
/*!******************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/AmpEditor.ts ***!
  \******************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AmpEditor = void 0;
var AzureMediaPlayer_1 = __webpack_require__(/*! ./ivAmp/AzureMediaPlayer */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/AzureMediaPlayer.ts");
var AmpTrimPlugin_1 = __webpack_require__(/*! ./ivAmp/AmpTrimPlugin */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/AmpTrimPlugin.ts");
var LanguageUtil_1 = __webpack_require__(/*! ./lib/LanguageUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/LanguageUtil.ts");
var AmpEditor = exports.AmpEditor = (function () {
    function AmpEditor(config) {
        var _this = this;
        this.config = config;
        if (!this.config.title)
            this.config.title = AmpEditor.lu.translate("Edit video");
        $(".editor-title").text(config.title);
        this.trimEffect = null;
        this.resizeEffect = null;
        if (this.config.currentEffects && this.config.currentEffects.length) {
            var trimEffects = this.config.currentEffects.filter(function (e) {
                return e.$type.indexOf("ImageVault.Common.Data.Effects.TrimEffect,") > -1;
            });
            if (trimEffects && trimEffects.length) {
                this.trimEffect = trimEffects[trimEffects.length - 1];
            }
            var resizeEffects = this.config.currentEffects.filter(function (e) {
                console.log(JSON.stringify(e));
                return e.$type.indexOf("ImageVault.Common.Data.Effects.ResizeEffect,") > -1;
            });
            if (resizeEffects && resizeEffects.length) {
                this.resizeEffect = resizeEffects[resizeEffects.length - 1];
            }
        }
        var videoId = "ampEditor-x";
        var videoUrl = this.config.addAssetUrlParameters(this.config.originalUrl);
        var width = this.config.originalImageWidth;
        var height = this.config.originalImageWidth;
        $('\
<div>\
    <video id="' + videoId + '" width="' + width + '" height="' + height + '" class="azuremediaplayer amp-default-skin ivAmp-editor" preload="metadata" autoplay controls data-ivmdurl="' + videoUrl + '">\
        <p>' + AmpEditor.lu.translate("To view this video please enable JavaScript, and consider upgrading to a web browser that supports HTML5 video") + '</p>\
    </video>\
    <div id="editor-buttons-area-container">\
        <div id="editor-buttons-area">\
            <div class="control-area video-control-area">\
            </div>\
            <div id="editor-actions" class="video-actions">\
                <a id="save-editor" href="#" class="propertymedia-btn save-button">' + this.config.editorOkButtonText + '</a>\
                <a id="cancel-editor" href="#" class="propertymedia-btn cancel-button">' + this.config.editorCancelButtonText + '</a>\
            </div>\
        </div>\
    </div>\
</div>\
').appendTo("#editor");
        var plugins = {};
        var trimPluginOptions = {};
        if (this.trimEffect) {
            trimPluginOptions.start = this.trimEffect.Start;
            trimPluginOptions.stop = this.trimEffect.Stop;
        }
        var rendererData = config.rendererData;
        if (!rendererData || typeof rendererData !== 'object') {
            rendererData = {};
        }
        if (!rendererData.keyFrames) {
            var duration = rendererData.duration;
            var keyFrameInterval = rendererData.keyFrameInterval || 2;
            if (duration > 0) {
                var keyframes = [];
                for (var i = 0; i < duration; i += keyFrameInterval) {
                    keyframes.push(i);
                }
                rendererData.keyFrames = keyframes;
            }
        }
        trimPluginOptions.keyFrames = rendererData.keyFrames;
        plugins[AmpTrimPlugin_1.AmpIvTrimPlugin.pluginId] = trimPluginOptions;
        var startAt = 0;
        if (this.trimEffect && this.trimEffect.Start)
            startAt = this.trimEffect.Start;
        var options = { debug: true, plugins: plugins, autoplay: true, controls: true, startAt: startAt, initPaused: true };
        AzureMediaPlayer_1.AzureMediaPlayer.setupAsync(videoId, options).then(function (e) {
            _this.amp = e;
            _this.config.$preloadobj.fadeOut(400);
        }).catch(function (e) {
            _this.config.hideSpinner();
            _this.config.showErrorOnPreloadScreen(AmpEditor.lu.translate("Error setting up video editor"), e);
        });
    }
    AmpEditor.prototype.updateCurrentEffects = function () {
        var effectArray = [];
        if (this.resizeEffect)
            effectArray.push(this.resizeEffect);
        var trimEffect = AmpTrimPlugin_1.AmpIvTrimPlugin.current.getCurrentTrimEffect();
        effectArray.push(trimEffect);
        this.config.currentEffects = effectArray;
    };
    AmpEditor.lu = LanguageUtil_1.LanguageUtil.registerTranslations("AmpEditor", ["sv", "no", "de"], {
        "Edit video": [
            "Redigera video",
            "Redigere video",
            "Video bearbeiten"
        ],
        "To view this video please enable JavaScript, and consider upgrading to a web browser that supports HTML5 video": [
            "För att kunna se denna video, aktivera javascript och uppgradera gärna webbläsaren till en som stödjer HTML5 videoelement",
            "For å se denne videoen, vennligst aktiver JavaScript, og vurder å oppgradere til en nettleser som støtter HTML5-video",
            "Um dieses Video anzuzeigen, aktivieren Sie bitte JavaScript und erwägen Sie ein Upgrade auf einen Webbrowser, der HTML5-Videos unterstützt"
        ],
        "Error setting up video editor": [
            "Fel vid aktivering av video",
            "Feil ved konfigurering av videoredigerer",
            "Fehler beim Einrichten des Video-Editors"
        ],
    });
    return AmpEditor;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/AreaOfInterest.ts":
/*!***********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/AreaOfInterest.ts ***!
  \***********************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AreaOfInterestUtil = void 0;
var AreaOfInterestUtil = (function () {
    function AreaOfInterestUtil() {
    }
    AreaOfInterestUtil.adjustForCrop = function (aoi, startWidth, startHeight, x, y, width, height) {
        aoi.X -= 1.0 * x / startWidth;
        aoi.Y -= 1.0 * y / startHeight;
        var xm = 1.0 * startWidth / width;
        var ym = 1.0 * startHeight / height;
        aoi.X *= xm;
        aoi.Y *= ym;
        aoi.Width *= xm;
        aoi.Height *= ym;
    };
    return AreaOfInterestUtil;
}());
exports.AreaOfInterestUtil = AreaOfInterestUtil;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/EffectUtil.ts":
/*!*******************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/EffectUtil.ts ***!
  \*******************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.EffectUtil = void 0;
var AreaOfInterest_1 = __webpack_require__(/*! ./AreaOfInterest */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/AreaOfInterest.ts");
var EffectUtil = (function () {
    function EffectUtil() {
    }
    EffectUtil.applyCrop = function (cropArea, x, y, width, height, areaOfInterest) {
        var startWidth = cropArea.width;
        var startHeight = cropArea.height;
        cropArea.x += x / cropArea.z;
        cropArea.y += y / cropArea.z;
        cropArea.width = width / cropArea.z;
        cropArea.height = height / cropArea.z;
        if (areaOfInterest) {
            AreaOfInterest_1.AreaOfInterestUtil.adjustForCrop(areaOfInterest, startWidth, startHeight, cropArea.x, cropArea.y, cropArea.width, cropArea.height);
        }
    };
    EffectUtil.applyResize = function (cropArea, width, height, resizeMode, zoomOnly, areaOfInterest) {
        var cw = cropArea.width * cropArea.z;
        var ch = cropArea.height * cropArea.z;
        if (resizeMode === 1) {
            var cropCenterX = 0.5;
            var cropCenterY = 0.5;
            if (areaOfInterest) {
                cropCenterX = areaOfInterest.X + areaOfInterest.Width / 2;
                cropCenterY = areaOfInterest.Y + areaOfInterest.Height / 2;
            }
            if (width && height) {
                var ear = width / height;
                var car = cw / ch;
                if (ear < car) {
                    if (ch < height) {
                        height = ch;
                        width = ear * height;
                    }
                    var yMin = cropArea.x;
                    var yMax = yMin + cropArea.width;
                    cropArea.z = height / cropArea.height;
                    cropArea.x += cropArea.width * cropCenterX - (width / cropArea.z) / 2;
                    if (cropArea.x < yMin)
                        cropArea.x = yMin;
                    else if (cropArea.x + width / cropArea.z > yMax)
                        cropArea.x = yMax - width / cropArea.z;
                }
                else {
                    if (cw < width) {
                        width = cw;
                        height = width / ear;
                    }
                    var yMin = cropArea.y;
                    var yMax = yMin + cropArea.height;
                    cropArea.z = width / cropArea.width;
                    cropArea.y += cropArea.height * cropCenterY - (height / cropArea.z) / 2;
                    if (cropArea.y < yMin)
                        cropArea.y = yMin;
                    else if (cropArea.y + height / cropArea.z > yMax)
                        cropArea.y = yMax - height / cropArea.z;
                }
                if (areaOfInterest) {
                    AreaOfInterest_1.AreaOfInterestUtil.adjustForCrop(areaOfInterest, cropArea.width * cropArea.z, cropArea.height * cropArea.z, cropArea.x * cropArea.z, cropArea.y * cropArea.z, width, height);
                }
                cropArea.width = width / cropArea.z;
                cropArea.height = height / cropArea.z;
            }
        }
        else {
            if (width && height) {
                if (width <= cw || height <= ch) {
                    var ear = width / height;
                    var car = cw / ch;
                    if (ear < car) {
                        cropArea.z = width / cropArea.width;
                        if (!zoomOnly) {
                            var oldHeight = cropArea.height;
                            cropArea.height = cropArea.width / ear;
                            cropArea.y -= Math.round((cropArea.height - oldHeight) / 2);
                        }
                    }
                    else {
                        cropArea.z = height / cropArea.height;
                        if (!zoomOnly) {
                            var oldWidth = cropArea.width;
                            cropArea.width = cropArea.height * ear;
                            cropArea.x -= Math.round((cropArea.width - oldWidth) / 2);
                        }
                    }
                }
            }
            else if (width) {
                if (width < cw) {
                    cropArea.z = width / cropArea.width;
                }
            }
            else if (height) {
                if (height < ch) {
                    cropArea.z = height / cropArea.height;
                }
            }
        }
    };
    EffectUtil.toString = function (ca) {
        return "Offset:".concat(ca.x, ",").concat(ca.y, " Size:").concat(ca.width, "x").concat(ca.height, " Zoom:").concat(ca.z);
    };
    return EffectUtil;
}());
exports.EffectUtil = EffectUtil;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/config.ts":
/*!***************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/config.ts ***!
  \***************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Config = exports.CoreSettings = exports.InputParameters = void 0;
var effects_1 = __webpack_require__(/*! ./effects */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts");
var InputParameters = (function () {
    function InputParameters() {
    }
    return InputParameters;
}());
exports.InputParameters = InputParameters;
var CoreSettings = (function () {
    function CoreSettings() {
    }
    return CoreSettings;
}());
exports.CoreSettings = CoreSettings;
var Config = (function () {
    function Config() {
        this.imageId = null;
        this.client = null;
        this.$preloadobj = null;
        this.editorWidth = 1024;
        this.editorHeight = 768;
        this.mediaUrlBase = null;
        this.currentEffects = null;
        this.resizeMode = 0;
        this.propertyWidth = null;
        this.propertyHeight = null;
        this.ivCoreProxy = null;
        this.ivUiAuthUrl = null;
        this.publishingIdentifier = null;
        this.editorPopupMode = null;
        this.nodeInfo = null;
        this.editorDisabledOriginalFormatNotSupported = "";
        this.editorDisabledOriginalToSmall = "";
        this.editorDisabledNoAccessToMedia = "";
        this.editorWidthInputLabel = "width";
        this.editorHeightInputLabel = "height";
        this.editorOkButtonText = "ok";
        this.editorCancelButtonText = "cancel";
        this.editorWarningIconText = "warning: Now your picture is showing in a reduced size because the image does not fit in the workspace. When you publish the image size will be correct.";
        this.editorReloadButtonText = "Reload";
        this.editorLoadErrorText = "An error occurred while loading the editor.";
        this.errorCallingImageVault = "Error calling ImageVault";
        this.errorCallingImageVaultRetrying = "Retrying";
        this.errorCallingImageVaultGaveUp = "Gave up! Please try again later or inform the ImageVault administrator about the error.";
        this.title = "";
    }
    Config.prototype.callback = function (callback, element) {
        if (element === void 0) { element = null; }
    };
    Config.prototype.getCurrentEffect = function (type) {
        for (var i = 0; i < this.currentEffects.length; i++) {
            var effect = this.currentEffects[i];
            if (effect.$type.split(",")[0].toLowerCase() === type.toLowerCase())
                return effect;
        }
        throw "Effect not found.";
    };
    Config.prototype.getCurrentCropEffect = function () {
        return this.getCurrentEffect(effects_1.CropEffect.typeName);
    };
    Config.prototype.getCurrentResizeEffect = function () {
        return this.getCurrentEffect(effects_1.ResizeEffect.typeName);
    };
    Config.prototype.getCurrentTrimEffect = function () {
        return this.getCurrentEffect(effects_1.TrimEffect.typeName);
    };
    Config.prototype.getCurrentExportMetadataEffect = function () {
        return this.getCurrentEffect(effects_1.ExportMetadataEffect.typeName);
    };
    Config.prototype.executeActionWithRetryAndInformOnPreload = function (action, maxRetries) {
        if (maxRetries === void 0) { maxRetries = 3; }
        var self = this;
        var retry = 0;
        var retryLogic = {
            retry: function () {
                var errorDetails = "";
                if (self.client._lastError) {
                    errorDetails = "[".concat(self.client._lastError.message, " (status:").concat(self.client._lastError.status, ")]");
                }
                retry++;
                if (retry > maxRetries) {
                    self.showErrorOnPreloadScreen(self.errorCallingImageVault, "".concat(self.errorCallingImageVaultGaveUp, " ").concat(errorDetails));
                    alert("".concat(self.errorCallingImageVault, ". ").concat(errorDetails));
                    return false;
                }
                else {
                    self.showErrorOnPreloadScreen(self.errorCallingImageVault, "".concat(self.errorCallingImageVaultRetrying, " ").concat(retry, "/").concat(maxRetries, " ").concat(errorDetails));
                    setTimeout(function () { action(retryLogic); }, 1000);
                    return true;
                }
            }
        };
        action(retryLogic);
    };
    Config.prototype.hideSpinner = function () {
        this.$preloadobj.css("background-image", "none");
    };
    Config.prototype.showErrorOnPreloadScreen = function (title, message) {
        var $title = $(".title", this.$preloadobj);
        var $message = $(".message", this.$preloadobj);
        $title.text(title);
        $message.text(message);
        var $messageBox = $(".message-box", this.$preloadobj);
        $messageBox.show();
    };
    Config.prototype.addAssetUrlParameters = function (url) {
        if (url && this.useMediaAuthenticationParameter) {
            var accessToken = this.client.getCachedAccessToken();
            var imageQs = "?ivauthorization=" + encodeURIComponent(accessToken);
            url += imageQs;
        }
        return url;
    };
    return Config;
}());
exports.Config = Config;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/editor.ts":
/*!***************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/editor.ts ***!
  \***************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Editor = void 0;
var JQuery = __webpack_require__(/*! jquery */ "jquery");
var imagevault_image_editor_1 = __webpack_require__(/*! ./imagevault-image-editor */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-image-editor.ts");
var imagevault_video_editor_1 = __webpack_require__(/*! ./imagevault-video-editor */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-video-editor.ts");
var config_1 = __webpack_require__(/*! ./config */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/config.ts");
var AmpEditor_1 = __webpack_require__(/*! ./AmpEditor */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/AmpEditor.ts");
var $ = window.iv_jQuery != undefined ? window.iv_jQuery : JQuery;
var Editor = (function () {
    function Editor() {
    }
    Editor.openEditorInstance = function (inputParameters) {
        if (inputParameters.currentEffects)
            inputParameters.currentEffects = JSON.parse(inputParameters.currentEffects);
        var config = new config_1.Config();
        config.$domobj = $("#editor");
        config.$preloadobj = $("#preloading");
        config.imageId = inputParameters.id;
        config.rendererId = inputParameters.rendererId;
        config.rendererData = inputParameters.rendererData;
        if (inputParameters.rendererData) {
            if (typeof inputParameters.rendererData === 'string') {
                try {
                    config.rendererData = JSON.parse(inputParameters.rendererData);
                }
                catch (_a) {
                    config.rendererData = inputParameters.rendererData;
                }
            }
            else {
                config.rendererData = inputParameters.rendererData;
            }
        }
        config.editorWidth = inputParameters.editorSettings.width;
        config.editorHeight = inputParameters.editorSettings.height;
        config.originalImageWidth = inputParameters.originalFormat.width;
        config.originalImageHeight = inputParameters.originalFormat.height;
        config.originalUrl = inputParameters.originalFormat.url;
        config.originalFormatContentType = inputParameters.originalFormatContentType;
        config.originalFormatUrl = inputParameters.originalFormatUrl;
        config.keepAspectRatio = inputParameters.keepAspectRatio;
        config.client = inputParameters.coreSettings.client;
        config.mediaUrlBase = inputParameters.coreSettings.mediaUrlBase;
        config.useMediaAuthenticationParameter = inputParameters.coreSettings.useMediaAuthenticationParameter;
        config.currentEffects = inputParameters.currentEffects;
        config.editorWidthInputLabel = inputParameters.languageSettings.editorWidthInputLabel;
        config.editorHeightInputLabel = inputParameters.languageSettings.editorHeightInputLabel;
        config.editorOkButtonText = inputParameters.languageSettings.editorOkButtonText;
        config.editorCancelButtonText = inputParameters.languageSettings.editorCancelButtonText;
        config.editorWarningIconText = inputParameters.languageSettings.editorWarningIconText;
        config.editorReloadButtonText = inputParameters.languageSettings.editorReloadButtonText;
        config.editorLoadErrorText = inputParameters.languageSettings.editorLoadErrorText;
        config.title = inputParameters.languageSettings.title;
        config.callback = inputParameters.callback;
        config.nodeInfo = inputParameters.nodeInfo;
        config.resizeMode = inputParameters.resizeMode;
        config.areaOfInterest = inputParameters.areaOfInterest;
        config.lang = inputParameters.lang;
        var targetFormat = inputParameters.targetFormat;
        if (config.lang) {
            $("html").attr("lang", config.lang);
            $(document).ready(function () {
                $("html").attr("lang", config.lang);
            });
        }
        if (targetFormat) {
            config.resizeMode = targetFormat.resizeMode;
            config.propertyWidth = targetFormat.width !== 0 ? targetFormat.width : null;
            config.propertyHeight = targetFormat.height !== 0 ? targetFormat.height : null;
        }
        if (config.nodeInfo) {
            $(".editor-wrapper").addClass("is-inline");
        }
        var editor;
        var mediaType = "";
        switch (config.rendererId) {
            case "BF2B805A-597A-4D46-87CA-90F3C9B9B50C":
                editor = new AmpEditor_1.AmpEditor(config);
                break;
            default:
                if (config.originalFormatContentType && config.originalFormatContentType.indexOf("video/") === 0) {
                    mediaType = "video";
                }
                else {
                    mediaType = "image";
                }
                switch (mediaType) {
                    case "video":
                        editor = new imagevault_video_editor_1.VideoEditor(config);
                        break;
                    default:
                        editor = new imagevault_image_editor_1.ImageEditor(config);
                        break;
                }
        }
        $(".cancel-button").click(function (e) {
            e.preventDefault();
            editor.config.callback(null);
            return false;
        });
        $(".save-button").click(function (e) {
            e.preventDefault();
            editor.updateCurrentEffects();
            editor.config.callback(JSON.stringify(editor.config.currentEffects));
            return false;
        });
        return editor;
    };
    return Editor;
}());
exports.Editor = Editor;
(window.ImageVault = window.ImageVault || {}).Editor = Editor;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts":
/*!****************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts ***!
  \****************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ExportMetadataEffect = exports.ExportMetadataTypes = exports.ChangeOutputFormatEffect = exports.TrimEffect = exports.CropEffect = exports.ResizeEffect = void 0;
var ResizeEffect = exports.ResizeEffect = (function () {
    function ResizeEffect(width, height, resizeMode) {
        this.$type = "".concat(ResizeEffect.typeName, ",").concat(ResizeEffect.assemblyName);
        this.ResizeMode = 0;
        this.Width = width;
        this.Height = height;
        this.ResizeMode = resizeMode;
    }
    ResizeEffect.typeName = "ImageVault.Common.Data.Effects.ResizeEffect";
    ResizeEffect.assemblyName = "ImageVault.Common";
    return ResizeEffect;
}());
var CropEffect = exports.CropEffect = (function () {
    function CropEffect(x, y, width, height) {
        this.$type = "".concat(CropEffect.typeName, ",").concat(CropEffect.assemblyName);
        this.X = x;
        this.Y = y;
        this.Width = width;
        this.Height = height;
    }
    CropEffect.typeName = "ImageVault.Common.Data.Effects.CropEffect";
    CropEffect.assemblyName = "ImageVault.Common";
    return CropEffect;
}());
var TrimEffect = exports.TrimEffect = (function () {
    function TrimEffect(start, stop) {
        this.$type = "".concat(TrimEffect.typeName, ",").concat(TrimEffect.assemblyName);
        this.Start = start;
        this.Stop = stop;
    }
    TrimEffect.typeName = "ImageVault.Common.Data.Effects.TrimEffect";
    TrimEffect.assemblyName = "ImageVault.Common";
    return TrimEffect;
}());
var ChangeOutputFormatEffect = exports.ChangeOutputFormatEffect = (function () {
    function ChangeOutputFormatEffect(contentType) {
        this.$type = "".concat(ChangeOutputFormatEffect.typeName, ",").concat(ChangeOutputFormatEffect.assemblyName);
        this.ContentType = contentType;
    }
    ChangeOutputFormatEffect.typeName = "ImageVault.Common.Data.Effects.ChangeOutputFormatEffect";
    ChangeOutputFormatEffect.assemblyName = "ImageVault.Common";
    return ChangeOutputFormatEffect;
}());
var ExportMetadataTypes;
(function (ExportMetadataTypes) {
    ExportMetadataTypes[ExportMetadataTypes["None"] = 0] = "None";
    ExportMetadataTypes[ExportMetadataTypes["EmbeddedXmp"] = 1] = "EmbeddedXmp";
})(ExportMetadataTypes || (exports.ExportMetadataTypes = ExportMetadataTypes = {}));
var ExportMetadataEffect = exports.ExportMetadataEffect = (function () {
    function ExportMetadataEffect(metadataType) {
        this.$type = "".concat(ExportMetadataEffect.typeName, ",").concat(ExportMetadataEffect.assemblyName);
        this.MetadataType = metadataType;
    }
    ExportMetadataEffect.typeName = "ImageVault.Common.Data.Effects.ExportMetadataEffect";
    ExportMetadataEffect.assemblyName = "ImageVault.Common";
    return ExportMetadataEffect;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts":
/*!****************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts ***!
  \****************************************************************************************/
/***/ (function(__unused_webpack_module, exports) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ImageFormat = exports.ThumbnailFormat = exports.WebMediaFormat = exports.TransformableMediaFormat = exports.OriginalFormat = exports.MediaFormatOutputType = exports.MediaFormatBase = void 0;
var MediaFormatBase = (function () {
    function MediaFormatBase() {
    }
    return MediaFormatBase;
}());
exports.MediaFormatBase = MediaFormatBase;
var MediaFormatOutputType;
(function (MediaFormatOutputType) {
    MediaFormatOutputType[MediaFormatOutputType["Unknown"] = 9999] = "Unknown";
    MediaFormatOutputType[MediaFormatOutputType["WebSafe"] = 0] = "WebSafe";
    MediaFormatOutputType[MediaFormatOutputType["Jpeg"] = 1] = "Jpeg";
    MediaFormatOutputType[MediaFormatOutputType["Tiff"] = 2] = "Tiff";
    MediaFormatOutputType[MediaFormatOutputType["Png"] = 4] = "Png";
    MediaFormatOutputType[MediaFormatOutputType["Gif"] = 5] = "Gif";
    MediaFormatOutputType[MediaFormatOutputType["Original"] = 6] = "Original";
})(MediaFormatOutputType || (exports.MediaFormatOutputType = MediaFormatOutputType = {}));
var OriginalFormat = (function (_super) {
    __extends(OriginalFormat, _super);
    function OriginalFormat() {
        var _this = _super.call(this) || this;
        _this.Id = 0;
        return _this;
    }
    return OriginalFormat;
}(MediaFormatBase));
exports.OriginalFormat = OriginalFormat;
var TransformableMediaFormat = (function (_super) {
    __extends(TransformableMediaFormat, _super);
    function TransformableMediaFormat() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return TransformableMediaFormat;
}(MediaFormatBase));
exports.TransformableMediaFormat = TransformableMediaFormat;
var WebMediaFormat = exports.WebMediaFormat = (function (_super) {
    __extends(WebMediaFormat, _super);
    function WebMediaFormat(effects) {
        if (effects === void 0) { effects = null; }
        var _this = _super.call(this) || this;
        _this.$type = "".concat(WebMediaFormat.typeName, ",").concat(WebMediaFormat.assemblyName);
        _this.Effects = effects;
        return _this;
    }
    WebMediaFormat.typeName = "ImageVault.Common.Data.WebMediaFormat";
    WebMediaFormat.assemblyName = "ImageVault.Common";
    return WebMediaFormat;
}(TransformableMediaFormat));
var ThumbnailFormat = exports.ThumbnailFormat = (function (_super) {
    __extends(ThumbnailFormat, _super);
    function ThumbnailFormat() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.$type = "".concat(ThumbnailFormat.typeName, ",").concat(ThumbnailFormat.assemblyName);
        return _this;
    }
    ThumbnailFormat.typeName = "ImageVault.Common.Data.ThumbnailFormat";
    ThumbnailFormat.assemblyName = "ImageVault.Common";
    return ThumbnailFormat;
}(WebMediaFormat));
var ImageFormat = exports.ImageFormat = (function (_super) {
    __extends(ImageFormat, _super);
    function ImageFormat(mediaFormatOutputType, compressionQuality, effects) {
        if (mediaFormatOutputType === void 0) { mediaFormatOutputType = undefined; }
        if (compressionQuality === void 0) { compressionQuality = undefined; }
        if (effects === void 0) { effects = undefined; }
        var _this = _super.call(this) || this;
        _this.$type = "".concat(ImageFormat.typeName, ",").concat(ImageFormat.assemblyName);
        _this.MediaFormatOutputType = mediaFormatOutputType;
        _this.CompressionQuality = compressionQuality;
        _this.Effects = effects;
        return _this;
    }
    ImageFormat.typeName = "ImageVault.Common.Data.ImageFormat";
    ImageFormat.assemblyName = "ImageVault.Common";
    return ImageFormat;
}(ThumbnailFormat));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-client.ts":
/*!**************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-client.ts ***!
  \**************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Client = void 0;
var JQuery = __webpack_require__(/*! jquery */ "jquery");
var $ = window.iv_jQuery != undefined ? window.iv_jQuery : JQuery;
var Client = (function () {
    function Client(config) {
        this.core = null;
        this.authUrl = null;
        this.username = null;
        this.password = null;
        this.authMethod = "active";
        this.impersonate_as = null;
        this.roles = null;
        this.authToken = null;
        this.accessToken = null;
        this._lastError = null;
        this.grant_type = null;
        this.resourceOwnerUsername = null;
        this.resourceOwnerPassword = null;
        this._Base64 = {
            _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
            encode: function (input) {
                var output = "";
                var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
                var i = 0;
                input = this._utf8_encode(input);
                while (i < input.length) {
                    chr1 = input.charCodeAt(i++);
                    chr2 = input.charCodeAt(i++);
                    chr3 = input.charCodeAt(i++);
                    enc1 = chr1 >> 2;
                    enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                    enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                    enc4 = chr3 & 63;
                    if (isNaN(chr2)) {
                        enc3 = enc4 = 64;
                    }
                    else if (isNaN(chr3)) {
                        enc4 = 64;
                    }
                    output = output +
                        this._keyStr.charAt(enc1) +
                        this._keyStr.charAt(enc2) +
                        this._keyStr.charAt(enc3) +
                        this._keyStr.charAt(enc4);
                }
                return output;
            },
            decode: function (input) {
                var output = "";
                var chr1, chr2, chr3;
                var enc1, enc2, enc3, enc4;
                var i = 0;
                input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
                while (i < input.length) {
                    enc1 = this._keyStr.indexOf(input.charAt(i++));
                    enc2 = this._keyStr.indexOf(input.charAt(i++));
                    enc3 = this._keyStr.indexOf(input.charAt(i++));
                    enc4 = this._keyStr.indexOf(input.charAt(i++));
                    chr1 = (enc1 << 2) | (enc2 >> 4);
                    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                    chr3 = ((enc3 & 3) << 6) | enc4;
                    output = output + String.fromCharCode(chr1);
                    if (enc3 !== 64) {
                        output = output + String.fromCharCode(chr2);
                    }
                    if (enc4 !== 64) {
                        output = output + String.fromCharCode(chr3);
                    }
                }
                output = this._utf8_decode(output);
                return output;
            },
            _utf8_encode: function (string) {
                string = string.replace(/\r\n/g, "\n");
                var utftext = "";
                for (var n = 0; n < string.length; n++) {
                    var c = string.charCodeAt(n);
                    if (c < 128) {
                        utftext += String.fromCharCode(c);
                    }
                    else if ((c > 127) && (c < 2048)) {
                        utftext += String.fromCharCode((c >> 6) | 192);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }
                    else {
                        utftext += String.fromCharCode((c >> 12) | 224);
                        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }
                }
                return utftext;
            },
            _utf8_decode: function (utftext) {
                var string = "";
                var i = 0;
                var c, c2, c3;
                while (i < utftext.length) {
                    c = utftext.charCodeAt(i);
                    if (c < 128) {
                        string += String.fromCharCode(c);
                        i++;
                    }
                    else if ((c > 191) && (c < 224)) {
                        c2 = utftext.charCodeAt(i + 1);
                        string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                        i += 2;
                    }
                    else {
                        c2 = utftext.charCodeAt(i + 1);
                        c3 = utftext.charCodeAt(i + 2);
                        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                        i += 3;
                    }
                }
                return string;
            }
        };
        $.extend(this, config);
        if (this.core)
            if (this.core[this.core.length - 1] !== '/')
                this.core = this.core + "/";
        if (this.authUrl)
            if (this.authUrl[this.authUrl.length - 1] !== '/')
                this.authUrl = this.authUrl + "/";
    }
    Client.prototype.json = function (service, args, callback) {
        this._innerCall(service, args, callback, { dataType: 'JSON' });
    };
    Client.prototype.html = function (service, args, callback) {
        this._innerCall(service, args, callback, { dataType: 'HTML' });
    };
    Client.prototype._innerCall = function (service, args, callback, config) {
        var _this = this;
        this._lastError = null;
        if (typeof args === "function") {
            callback = args;
            args = null;
        }
        if (typeof args === "object" ||
            (typeof args === "string" && args.length > 0 && args.charAt(0) !== '{' && args.charAt(0) !== '[')) {
            args = JSON.stringify(args);
        }
        this._getAuthToken(function (token) {
            if (_this.authMethod === "none" || token !== null) {
                _this._callServiceWithToken(token, service, args, callback, config);
            }
            else {
                callback(null);
            }
        });
    };
    Client.prototype._makeAbsoluteUrl = function (url) {
        var a = document.createElement("a");
        a.href = url;
        url = a.href;
        return url;
    };
    Client.prototype._callServiceWithToken = function (token, service, args, callback, config) {
        var _this = this;
        var self = this;
        var url = self.core + service;
        var type = 'POST';
        if (args == null) {
            type = 'GET';
        }
        var headers = {};
        if (token != null) {
            headers["Authorization"] = token;
            headers["IVAuthorization"] = token;
        }
        var ajaxConfig = {
            url: self._makeAbsoluteUrl(url),
            type: type,
            data: args,
            contentType: 'application/json; charset=utf-8',
            headers: headers,
            success: function (data) {
                if (config.dataType === "JSON" && typeof data === "string")
                    data = JSON.parse(data);
                callback(data);
            },
            error: null
        };
        ajaxConfig = $.extend(ajaxConfig, config);
        var reAuthFunction = function (retryCall) {
            _this._reauthenticateUsingActiveAuthentication(retryCall);
        };
        var retryCallFunction = function (t) {
            if (t !== null) {
                ajaxConfig.headers["Authorization"] = t;
                ajaxConfig.headers["IVAuthorization"] = t;
            }
            reAuthFunction = null;
            _this._ajaxWithCorsSupport(ajaxConfig);
        };
        ajaxConfig.error = function (jqXhr, status, err) {
            if (jqXhr.status === 401 && typeof reAuthFunction === "function") {
                reAuthFunction(retryCallFunction);
            }
            else {
                var error = { message: err, status: jqXhr.status };
                _this._lastError = error;
                callback(null, error);
            }
        };
        self._ajaxWithCorsSupport(ajaxConfig);
    };
    Client.prototype._reauthenticateUsingActiveAuthentication = function (callback) {
        this.authToken = null;
        this.sessionToken = null;
        this._getAuthToken(callback);
    };
    Client.prototype._ajaxWithCorsSupport = function (config) {
        var oldSupportCors = $.support.cors;
        $.support.cors = true;
        config.crossDomain = true;
        config.xhrFields = { withCredentials: true };
        var csrfTokenElement = document.querySelector("input[name='__ApiRequestVerificationToken']");
        if (csrfTokenElement) {
            var csrfToken = csrfTokenElement.value;
            config.headers["__ApiRequestVerificationToken"] = csrfToken;
        }
        var oldComplete = config.complete;
        config.complete = function (jqXhr, status, responseText) {
            $.support.cors = oldSupportCors;
            if (typeof oldComplete === "function") {
                oldComplete(jqXhr, status, responseText);
            }
        };
        $.ajax(config);
    };
    Client.prototype._getAuthToken = function (callback) {
        var self = this;
        if (self.authMethod === "none") {
            self.authToken = null;
            callback(null);
            return;
        }
        if (self.authToken &&
            self.accessToken &&
            self.accessToken.expires_at &&
            self.accessToken.expires_at > new Date()) {
            callback(self.authToken);
            return;
        }
        var params = {
            grant_type: null,
            username: null,
            password: null,
            impersonate_as: null,
            roles: null
        };
        if (self.grant_type)
            params.grant_type = self.grant_type;
        else
            params.grant_type = 'client_credentials';
        if (self.resourceOwnerUsername && self.resourceOwnerPassword) {
            params.username = self.resourceOwnerUsername;
            params.password = self.resourceOwnerPassword;
        }
        if (self.impersonate_as)
            params.impersonate_as = self.impersonate_as;
        if (self.roles)
            params.roles = self.roles;
        var headers = {};
        if (self.username && self.password) {
            var untoken = "Basic " + self._Base64.encode(self.username + ":" + self.password);
            headers = { 'Authorization': untoken };
        }
        var url = this.authUrl;
        if (!url)
            url = this.core;
        url += "oauth/token";
        var config = {
            url: self._makeAbsoluteUrl(url),
            type: 'POST',
            headers: headers,
            contentType: 'application/x-www-form-urlencoded; charset=utf-8',
            cache: false,
            data: params,
            success: function (data) {
                var accessToken = self.accessToken = data;
                var expires = new Date();
                expires.setSeconds(expires.getSeconds() + accessToken.expires_in);
                self.accessToken.expires_at = expires;
                self.accessToken = accessToken;
                self.authToken = accessToken.token_type + " " + accessToken.access_token;
                callback(self.authToken);
            },
            error: function (xhr) {
                try {
                    var error = JSON.parse(xhr.responseText);
                    if (!error.message) {
                        error.message = error.error_description;
                    }
                    self._lastError = { status: xhr.status, message: error };
                }
                catch (e) {
                    self._lastError = { status: xhr.status, message: { message: xhr.responseText } };
                }
                callback(null, self._lastError);
            }
        };
        self._ajaxWithCorsSupport(config);
    };
    Client.prototype.getLastErrorMessage = function () {
        if (this._lastError && this._lastError.message)
            return this._lastError.message;
        return null;
    };
    return Client;
}());
exports.Client = Client;
(window.ImageVault = window.ImageVault || {}).Client = Client;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-image-editor.ts":
/*!********************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-image-editor.ts ***!
  \********************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ImageEditor = void 0;
var JQuery = __webpack_require__(/*! jquery */ "jquery");
var EffectUtil_1 = __webpack_require__(/*! ./EffectUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/EffectUtil.ts");
var effects_1 = __webpack_require__(/*! ./effects */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts");
var formats_1 = __webpack_require__(/*! ./formats */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts");
var $ = window.iv_jQuery != undefined ? window.iv_jQuery : JQuery;
$.fn.cssVal = function (cssPropertyName) {
    var stringVal = $(this).css(cssPropertyName);
    if (!stringVal || stringVal === "auto")
        return 0;
    return parseFloat(stringVal);
};
var ImageEditor = (function () {
    function ImageEditor(config) {
        this.$imageobj = null;
        this.overlay = null;
        this.$outline = null;
        this.$selection = null;
        this.$selectionImage = null;
        this.$workspace = null;
        this.$nwResizeHandler = null;
        this.$swResizeHandler = null;
        this.$seResizeHandler = null;
        this.$neResizeHandler = null;
        this.$nResizeHandler = null;
        this.$sResizeHandler = null;
        this.$wResizeHandler = null;
        this.$eResizeHandler = null;
        this.$keepAspectRatioButton = null;
        this.$cropWarningImage = null;
        this.$reloadEditorButton = null;
        this.$slider = null;
        this.$loader = null;
        this.changeSelectionImageTimout = null;
        this.maxWidthForEditImage = 4000;
        this.maxHeightForEditImage = 4000;
        this.cropCoordinates = {
            top: 100,
            left: 100,
            height: 100,
            width: 100,
            scale: 1,
            topFromImage: 0,
            leftFromImage: 0,
            unscaledWidth: 100,
            unscaledHeight: 100
        };
        this.cropAspectRatio = null;
        this.zoomLevel = 100;
        this.originalZoomLevel = null;
        this.step = 10;
        this.aspectRatio = null;
        this.oldImageWidthCtrlValue = null;
        this.oldImageHeightCtrlValue = null;
        this.dragImage = false;
        this.dragHandler = false;
        this.currentHandle = null;
        this.mouseX = 0;
        this.mouseY = 0;
        this.cropareaBorderWidth = 1;
        this.overlayOpacity = 0.75;
        this.outlineOpacity = 1;
        this.firstTime = false;
        this.editorSliderHeight = 20;
        var self = this;
        this.config = config;
        if (!config.currentEffects || !config.currentEffects.length) {
            var initialEffectsFromOriginal = [];
            initialEffectsFromOriginal.push({
                $type: "ImageVault.Common.Data.Effects.ResizeEffect,ImageVault.Common",
                Width: config.originalImageWidth,
                Height: config.originalImageHeight
            });
            config.currentEffects = JSON.parse(JSON.stringify(initialEffectsFromOriginal));
        }
        config.title = config.title !== undefined ? config.title : "Edit image";
        $(".editor-title").text(config.title);
        this.setupDom();
        this.cropareaBorderWidth = Math.round(parseFloat(this.$outline.css("borderTopWidth").replace("px", "")));
        if (this.cropareaBorderWidth === null)
            this.cropareaBorderWidth = 0;
        this.editorSliderHeight = $("#editor-buttons-area-container").outerHeight() + 30;
        this.aspectRatio = this.config.originalImageWidth / this.config.originalImageHeight;
        if (this.config.nodeInfo) {
            this.workspaceHeight = (this.calculateWorkSpaceHeight() - 2 - this.cropareaBorderWidth * 2);
        }
        else {
            this.workspaceHeight = (this.calculateWorkSpaceHeight() - 2 - this.cropareaBorderWidth * 2) - 100;
        }
        this.workspaceWidth = (this.config.editorWidth - 2 - this.cropareaBorderWidth * 2) - 60;
        this.setupLanguage();
        this.setupWindowSize();
        try {
            this.updateEffects(this.config.currentEffects);
        }
        catch (e) {
            alert(this.config.editorLoadErrorText + "\r\nError message details: " + e);
            this.config.callback(null);
            if (window.ownerDocument)
                window.ownerDocument.close();
        }
        this.registerEvents();
        this.createImageData();
        if (config.resizeMode === 0 && config.currentEffects && config.currentEffects.length > 0) {
            for (var i = 0; i < config.currentEffects.length; i++) {
                var effect = config.currentEffects[i];
                switch (effect.$type.split(",")[0].toLowerCase()) {
                    case "imagevault.common.data.effects.cropeffect":
                        var cropEffect = effect;
                        if (!cropEffect.X || !cropEffect.Y) {
                            self.setSizeAndCenterImageInCropArea(self);
                        }
                }
            }
        }
    }
    ImageEditor.prototype.createImageData = function () {
        var _this = this;
        var self = this;
        var effectArray = [];
        effectArray.push(new effects_1.ResizeEffect(this.maxWidthForEditImage, this.maxHeightForEditImage, 0));
        var parameters = {
            Filter: { Id: [this.config.imageId] },
            Populate: {
                MediaFormats: [
                    new formats_1.ImageFormat(formats_1.MediaFormatOutputType.Jpeg, 70, effectArray),
                    new formats_1.ImageFormat(undefined, 70, effectArray),
                    new formats_1.ImageFormat(formats_1.MediaFormatOutputType.Original, undefined, effectArray),
                ]
            },
            MediaUrlBase: this.config.mediaUrlBase
        };
        var json = JSON.stringify(parameters);
        this.config.executeActionWithRetryAndInformOnPreload(function (retryLogic) {
            self.config.client.json("MediaService/Find", json, function (x) {
                if (!x || x.length < 1) {
                    if (!retryLogic.retry()) {
                        _this.config.callback(null);
                    }
                    return;
                }
                var _a = __read(x[0].MediaConversions, 3), compressedJpegMediaConvertion = _a[0], compressedWebSafeMediaConvertion = _a[1], originalMediaConvertion = _a[2];
                self.mediaData = {
                    compressedJpegMediaUrl: compressedJpegMediaConvertion.Url,
                    compressedWebSafeMediaUrl: compressedWebSafeMediaConvertion.Url,
                    originalMediaFileFormat: originalMediaConvertion.ContentType,
                    originalMediaWidth: originalMediaConvertion.Width,
                    originalMediaHeight: originalMediaConvertion.Height
                };
                self.setEditImageUrl();
            });
        });
    };
    ImageEditor.prototype.showLoader = function () {
        this.$loader.show();
    };
    ImageEditor.prototype.hideLoader = function () {
        this.$loader.hide();
    };
    ImageEditor.prototype.setSelectionImageEvent = function () {
        var self = this;
        self.$selectionImage.attr("src", "");
        $(document).mouseup(function () {
            self.setSelectionImage();
        });
    };
    ImageEditor.prototype.setSelectionImage = function () {
        var self = this;
        clearTimeout(self.changeSelectionImageTimout);
        self.$selectionImage.attr("src", "");
        if (self.maxWidthForEditImage < self.$imageobj.width()) {
            self.changeSelectionImageTimout = setTimeout(function () {
                self.showLoader();
                self.updateCurrentEffects();
                var parameters = {
                    Filter: { Id: [self.config.imageId] },
                    Populate: {
                        MediaFormats: [
                            new formats_1.ImageFormat(formats_1.MediaFormatOutputType.WebSafe, undefined, self.config.currentEffects),
                            new formats_1.ImageFormat(formats_1.MediaFormatOutputType.Jpeg, 80, self.config.currentEffects)
                        ]
                    },
                    MediaUrlBase: self.config.mediaUrlBase
                };
                var json = JSON.stringify(parameters);
                self.config.client.json("MediaService/Find", json, function (x) {
                    if (x == null) {
                        alert("Error calling ImageVault Core. [" +
                            self.config.client._lastError.message +
                            " (status:" +
                            self.config.client._lastError.status +
                            ")]");
                        self.config.callback(null);
                        return;
                    }
                    var selectionMediaConvertion = x[0].MediaConversions[0];
                    var selectionJpegMediaConvertion = x[0].MediaConversions[1];
                    var url = selectionMediaConvertion.Url;
                    if (self.mediaData.originalMediaFileFormat.toLowerCase().indexOf("tif") > 0) {
                        url = selectionJpegMediaConvertion.Url;
                    }
                    url = self.config.addAssetUrlParameters(url);
                    self.$selectionImage.attr("src", url);
                });
            }, 400);
        }
        else {
            self.hideLoader();
        }
    };
    ImageEditor.prototype.setEditImageUrl = function () {
        var self = this;
        if (self.mediaData != null) {
            var url = self.mediaData.compressedJpegMediaUrl;
            if (self.mediaData.originalMediaFileFormat.toLowerCase().indexOf("png") > 0) {
                url = self.mediaData.compressedWebSafeMediaUrl;
            }
            url = self.config.addAssetUrlParameters(url);
            self.$imageobj.attr("src", url);
            self.config.$preloadobj.fadeOut(400);
            self.resizeOverlay();
        }
    };
    ImageEditor.prototype.setupDom = function () {
        var _this = this;
        var self = this;
        this.$workspace = $('<div id="editor-workspace" />');
        this.$imageobj = $('<img id="editor-image" alt="Use the controls to alter the image" />');
        this.$workspace.append(this.$imageobj);
        this.config.$domobj.append(this.$workspace);
        this.$editorSlider = $('<div id="editor-slider" />');
        var $editorSliderInner = $('<div id="editor-slider-inner" />');
        this.$editorSlider.append($editorSliderInner);
        var $editorSliderMinValue = $('<div id="editor-slider-min-value">0%</div>');
        this.$slider = $('<div id="editor-slider-bar" class="iv-slider-bar" />').slider({
            range: "min",
            value: 0,
            min: 0,
            max: 100,
            step: 0.5,
            slide: function (event, ui) {
                return self.zoomImage(null, ui.value);
            }
        });
        var $editorSliderMaxValue = $('<div id="editor-slider-max-value">100%</div>');
        $editorSliderInner.append($editorSliderMinValue);
        $editorSliderInner.append(this.$slider);
        $editorSliderInner.append($editorSliderMaxValue);
        var $editorButtonsAreaContainer = $('<div id="editor-buttons-area-container" />');
        var $editorButtonsArea = $('<div id="editor-buttons-area" />');
        var $controlArea = $('<div class="control-area" />');
        var $divImageWidth = $('<div class="control-area-width"></div>');
        this.$labelImageWidth = $('<label id="label-image-width" for="image-width">Width:</label>');
        this.$inputImageWidth = $('<input id="image-width" type="text" tabindex=1 value="0" />');
        $divImageWidth.append(this.$labelImageWidth);
        $divImageWidth.append(this.$inputImageWidth);
        var $divImageHeight = $('<div class="control-area-height"></div>');
        this.$labelImageHeight = $('<label id="label-image-height" for="image-height">Height:</label>');
        this.$inputImageHeight = $('<input id="image-height" type="text" tabindex=2 value="0" />');
        $divImageHeight.append(this.$labelImageHeight);
        $divImageHeight.append(this.$inputImageHeight);
        $controlArea.append($divImageWidth);
        var activeClass = "inactive";
        if (this.config.keepAspectRatio) {
            activeClass = "active";
        }
        var $actionKeepAspectRatio = $('<a class="keep-aspect-ratio ' + activeClass + '" tabindex=0 href="#" title="Constrain proportions"><i class="fa fa-link"></i></a>');
        $controlArea.append($actionKeepAspectRatio);
        $controlArea.append($divImageHeight);
        $editorButtonsArea.append($controlArea);
        $editorButtonsArea.append(this.$editorSlider);
        this.$editorAction = $('<div id="editor-actions" />');
        this.$actionSaveEditor = $('<a id="save-editor" href="#" class="propertymedia-btn save-button">OK</a>');
        this
            .$actionCancelEditor =
            $('<a id="cancel-editor" href="#" class="propertymedia-btn cancel-button">Cancel</a>');
        this.$editorAction.append(this.$actionSaveEditor);
        this.$editorAction.append(this.$actionCancelEditor);
        $editorButtonsArea.append(this.$editorAction);
        $editorButtonsAreaContainer.append($editorButtonsArea);
        this.config.$domobj.append($editorButtonsAreaContainer);
        this.overlay = {
            $left: $('<div class="image-crop-overlay image-crop-overlay-left" />').insertAfter(this.$imageobj),
            $top: $('<div class="image-crop-overlay image-crop-overlay-top" />').insertAfter(this.$imageobj),
            $bottom: $('<div class="image-crop-overlay image-crop-overlay-bottom" />').insertAfter(this.$imageobj),
            $right: $('<div class="image-crop-overlay image-crop-overlay-right" />').insertAfter(this.$imageobj)
        };
        this
            .$loader =
            $("<div class=\"edit-image-loader-wrapper\"><div class=\"edit-image-loader\"></div>Adjusting focus...</div>");
        this.$outline = $('<div id="image-crop-outline" />')
            .css({
            opacity: this.outlineOpacity,
            position: "absolute",
            display: "block"
        }).append(this.$loader)
            .insertAfter(this.overlay.$right);
        this.$cropWarningImage = $('<div id="editor-croparea-warning" />');
        this.$outline.append(this.$cropWarningImage);
        this.$outline.append('<div class="editor-warning-message-popup" style="display: none;"></div>');
        this
            .$reloadEditorButton =
            $('<a href="#" id="reloadEditor" class="propertymedia-btn reload-button" style="display: none;"><span class="reload-label">Ladda om</span></a>');
        this.$outline.append(this.$reloadEditorButton);
        var timeout;
        this.$cropWarningImage.hover(function () {
            timeout = setTimeout(function () {
                $(".editor-warning-message-popup").fadeIn(500);
            }, 500);
        }, function () {
            clearTimeout(timeout);
            $(".editor-warning-message-popup").fadeOut(500);
        });
        this.$selection = $("<div />")
            .css({
            position: "absolute",
            overflow: "hidden"
        })
            .insertAfter(this.$outline);
        this.$selectionImage = $("<img class='selection-image'/>").css("position", "absolute");
        this.$selectionImage.on("load", function () {
            _this.hideLoader();
        });
        this.$selection.append(this.$selectionImage);
        this.$nwResizeHandler = $('<div class="image-crop-resize-handler" id="image-crop-nw-resize-handler" />')
            .css({
            opacity: 0.8,
            position: "absolute"
        })
            .insertAfter(this.$selection);
        this.$neResizeHandler = $('<div class="image-crop-resize-handler" id="image-crop-ne-resize-handler" />')
            .css({
            opacity: 0.8,
            position: "absolute"
        })
            .insertAfter(this.$selection);
        this.$swResizeHandler = $('<div class="image-crop-resize-handler" id="image-crop-sw-resize-handler" />')
            .css({
            opacity: 0.8,
            position: "absolute"
        })
            .insertAfter(this.$selection);
        this.$seResizeHandler = $('<div class="image-crop-resize-handler" id="image-crop-se-resize-handler" />')
            .css({
            opacity: 0.8,
            position: "absolute"
        })
            .insertAfter(this.$selection);
        this
            .$nResizeHandler =
            $('<div class="image-crop-resize-handler" id="image-crop-n-resize-handler" />')
                .css({
                opacity: 0.8,
                position: "absolute"
            })
                .insertAfter(this.$selection);
        this
            .$sResizeHandler =
            $('<div class="image-crop-resize-handler" id="image-crop-s-resize-handler" />')
                .css({
                opacity: 0.8,
                position: "absolute"
            })
                .insertAfter(this.$selection);
        this
            .$wResizeHandler =
            $('<div class="image-crop-resize-handler" id="image-crop-w-resize-handler" />')
                .css({
                opacity: 0.8,
                position: "absolute"
            })
                .insertAfter(this.$selection);
        this.$eResizeHandler =
            $('<div class="image-crop-resize-handler" id="image-crop-e-resize-handler" />')
                .css({
                opacity: 0.8,
                position: "absolute"
            })
                .insertAfter(this.$selection);
        this.$keepAspectRatioButton = $("a.keep-aspect-ratio", this.config.$domobj).click(function (e) {
            e.preventDefault();
            self.updateKeepAspectRatio(!self.config.keepAspectRatio);
            return false;
        });
    };
    ImageEditor.prototype.calculateWorkSpaceHeight = function () {
        return this.config.editorHeight - this.editorSliderHeight;
    };
    ImageEditor.prototype.setupLanguage = function () {
        this.$labelImageWidth.html(this.config.editorWidthInputLabel);
        this.$labelImageHeight.html(this.config.editorHeightInputLabel);
        this.$actionSaveEditor.html(this.config.editorOkButtonText);
        this.$actionCancelEditor.html(this.config.editorCancelButtonText);
        $(".editor-warning-message-popup").html(this.config
            .editorWarningIconText +
            "<div></div>");
        this.$reloadEditorButton.html("<span class=\"reload-label\">" + this.config.editorReloadButtonText + "</span>");
    };
    ImageEditor.prototype.setupWindowSize = function () {
        var headerHeight = 50;
        var containerPaddingVertical = 60;
        var margin = 5;
        if (this.config.nodeInfo) {
            headerHeight = 0;
            containerPaddingVertical = 0;
            margin = 2;
        }
        this.config.$domobj.css("width", this.config.editorWidth - 2).css("height", this.config.editorHeight - margin - headerHeight - containerPaddingVertical);
        this.$workspace.css("height", this.workspaceHeight + this.cropareaBorderWidth * 2);
        this.$workspace.css("width", this.workspaceWidth + this.cropareaBorderWidth * 2);
    };
    ImageEditor.prototype.resizeOverlay = function () {
        var outlineLeft = Math.round(this.$outline.position().left);
        var outlineTop = Math.round(this.$outline.position().top);
        var outlineWidth = Math.round(this.$outline.width());
        var outlineHeight = Math.round(this.$outline.height());
        var workspaceWidth = Math.round(this.$workspace.width());
        var workspaceHeight = Math.round(this.$workspace.height());
        this.overlay.$right
            .css("width", workspaceWidth)
            .css("height", outlineHeight + 2)
            .css("top", outlineTop)
            .css("left", (outlineLeft + outlineWidth + 1));
        this.overlay.$top
            .css("width", workspaceWidth + 75)
            .css("height", (outlineTop) + 30)
            .css("top", -30)
            .css("left", -30);
        this.overlay.$left
            .css("width", outlineLeft + 5)
            .css("height", outlineHeight + 2)
            .css("top", outlineTop)
            .css("left", -5);
        this.overlay.$bottom
            .css("width", workspaceWidth + 75)
            .css("height", workspaceHeight)
            .css("top", (outlineHeight + outlineTop + 2))
            .css("left", -5);
    };
    ImageEditor.prototype.resizeCropArea = function (coord) {
        this.cropCoordinates = coord;
        if (coord.width && coord.height) {
            this.cropAspectRatio = coord.width / coord.height;
        }
        this.updateSelection();
        this.setSelectionImage();
    };
    ImageEditor.prototype.updateKeepAspectRatio = function (keepAspectRatio) {
        this.config.keepAspectRatio = keepAspectRatio;
        this.updateResizeHandlers(null);
        if (this.config.keepAspectRatio) {
            this.$keepAspectRatioButton.addClass("active").removeClass("inactive");
        }
        else {
            this.$keepAspectRatioButton.removeClass("active").addClass("inactive");
        }
    };
    ImageEditor.prototype.updateEffects = function (currentEffects) {
        var cropArea = {
            x: 0, y: 0,
            width: this.config.originalImageWidth,
            height: this.config.originalImageHeight,
            z: 1
        };
        if (currentEffects && currentEffects.length > 0) {
            for (var i = 0; i < currentEffects.length; i++) {
                var effect = currentEffects[i];
                switch (effect.$type.split(",")[0].toLowerCase()) {
                    case "imagevault.common.data.effects.cropeffect":
                        EffectUtil_1.EffectUtil.applyCrop(cropArea, effect.X || 0, effect.Y || 0, effect.Width, effect.Height, this.config.areaOfInterest);
                        break;
                    case "imagevault.common.data.effects.resizeeffect":
                        EffectUtil_1.EffectUtil.applyResize(cropArea, effect.Width, effect.Height, effect.ResizeMode, null, this.config.areaOfInterest);
                        break;
                    case "imagevault.common.data.effects.exportmetadataeffect":
                        break;
                    default:
                        throw "Effect of type ".concat(effect.$type, " is not supported");
                }
            }
        }
        if (this.config.propertyWidth || this.config.propertyHeight) {
            EffectUtil_1.EffectUtil.applyResize(cropArea, this.config.propertyWidth, this.config.propertyHeight, this.config.resizeMode, null, this.config.areaOfInterest);
        }
        this.cropCoordinates.unscaledWidth = cropArea.width * cropArea.z;
        this.cropCoordinates.unscaledHeight = cropArea.height * cropArea.z;
        this.cropCoordinates.width = cropArea.width * cropArea.z;
        this.cropCoordinates.height = cropArea.height * cropArea.z;
        this.cropCoordinates.leftFromImage = cropArea.x * cropArea.z;
        this.cropCoordinates.topFromImage = cropArea.y * cropArea.z;
        this.cropCoordinates.scale = 1;
        var ww = this.workspaceWidth;
        if (this.config.nodeInfo) {
            ww = this.config.nodeInfo.contentWidth -
                this.config.nodeInfo.x +
                this.config.nodeInfo.navPaneWidth -
                this.cropareaBorderWidth * 4;
        }
        if (this.cropCoordinates.width > ww || this.cropCoordinates.height > this.workspaceHeight) {
            var workspaceArea = {
                x: 0,
                y: 0,
                width: this.cropCoordinates.width,
                height: this.cropCoordinates.height,
                z: 1
            };
            EffectUtil_1.EffectUtil.applyResize(workspaceArea, ww, this.workspaceHeight, 0, true);
            this.cropCoordinates.width = workspaceArea.width * workspaceArea.z;
            this.cropCoordinates.height = workspaceArea.height * workspaceArea.z;
            this.cropCoordinates.scale = 1 / workspaceArea.z;
            this.cropCoordinates.leftFromImage = this.cropCoordinates.leftFromImage * workspaceArea.z;
            this.cropCoordinates.topFromImage = this.cropCoordinates.topFromImage * workspaceArea.z;
        }
        if (this.config.nodeInfo) {
            var leftOffset = this.config.nodeInfo.x - this.config.nodeInfo.navPaneWidth;
            var topOffset = this.config.nodeInfo.y - this.config.nodeInfo.menuOffset;
            var padding = this.config.nodeInfo.containerBorderWidth - this.cropareaBorderWidth * 2;
            if (leftOffset < 0)
                leftOffset = 0;
            if (topOffset < 0)
                topOffset = 0;
            this.cropCoordinates.left = leftOffset + padding;
            this.cropCoordinates.top = topOffset + padding;
        }
        else {
            this.cropCoordinates.left = Math.round((this.workspaceWidth - this.cropCoordinates.width) / 2);
            this.cropCoordinates.top = Math.round((this.workspaceHeight - this.cropCoordinates.height) / 2);
        }
        var left, top;
        var z = cropArea.z / this.cropCoordinates.scale;
        this.resizeCropArea(this.cropCoordinates);
        this.updateWidthAndHeightControls();
        this.updateResizeHandlers(null);
        var outlineTop = this.$outline.cssVal("top");
        var outlineLeft = this.$outline.cssVal("left");
        top = outlineTop + this.cropareaBorderWidth - this.cropCoordinates.topFromImage;
        left = outlineLeft + this.cropareaBorderWidth - this.cropCoordinates.leftFromImage;
        var width = this.config.originalImageWidth * z;
        var height = this.config.originalImageHeight * z;
        if (this.config.nodeInfo && this.config.resizeMode === 0) {
            if (width < this.cropCoordinates.width) {
                left = this.cropCoordinates.left + this.cropareaBorderWidth;
            }
            if (height < this.cropCoordinates.height) {
                top = this.cropCoordinates.top + this.cropareaBorderWidth;
            }
        }
        left = Math.round(left);
        top = Math.round(top);
        this.$imageobj.css("left", left);
        this.$imageobj.css("top", top);
        this.$imageobj.css("width", width);
        this.$imageobj.css("height", height);
        this.zoomLevel = 100 * z;
        this.$slider.slider("value", this.zoomLevel);
    };
    ImageEditor.prototype.updateSelection = function () {
        if (this.config.keepAspectRatio) {
            if (this.cropCoordinates.left < 0) {
                this.cropCoordinates.left = 0;
                this.updateWidthAndHeightControls();
            }
            var workspaceWidth = this.$workspace.width();
            if ((this.cropCoordinates.width + this.cropCoordinates.left) > workspaceWidth) {
                var aspectRatio = (this.$inputImageWidth.val() + 0.0) / (this.$inputImageHeight.val() + 0.0);
                this.cropCoordinates.width = workspaceWidth - this.cropCoordinates.left;
                this.cropCoordinates.unscaledWidth = workspaceWidth - this.cropCoordinates.left;
                this.cropCoordinates.height = this.cropCoordinates.width / aspectRatio;
                this.cropCoordinates.unscaledHeight = this.cropCoordinates.height;
                this.updateWidthAndHeightControls();
            }
        }
        this.$outline.css("left", this.cropCoordinates.left).css("top", this.cropCoordinates.top);
        this.$outline.css("width", this.cropCoordinates.width).css("height", this.cropCoordinates.height);
        this.$selection.css({
            cursor: "pointer",
            display: "block",
            left: this.cropCoordinates.left + this.cropareaBorderWidth,
            top: this.cropCoordinates.top + this.cropareaBorderWidth
        })
            .width((this.cropCoordinates.width > 0) ? (this.cropCoordinates.width) : 0)
            .height((this.cropCoordinates.height > 0) ? (this.cropCoordinates.height) : 0);
        var resizeRatioW = this.cropCoordinates.width / this.config.originalImageWidth;
        var resizeRatioH = this.cropCoordinates.height / this.config.originalImageHeight;
        var resizeRatio = ((this.config.resizeMode === 0 && resizeRatioH < resizeRatioW) ||
            (this.config.resizeMode === 1 && resizeRatioH > resizeRatioW)
            ? resizeRatioH
            : resizeRatioW);
        this.originalZoomLevel = Math.round((100 * resizeRatio) * 1000) / 1000;
        var max = Math.round((100 / this.cropCoordinates.scale) * 1000) / 1000;
        this.$slider.slider("option", "min", this.originalZoomLevel);
        this.$slider.slider("option", "max", max);
        if (this.originalZoomLevel === max)
            this.$slider.slider("option", "min", this.originalZoomLevel - 0.01);
        this.resizeOverlay();
    };
    ImageEditor.prototype.resizeImage = function () {
        var resizeRatioW = this.cropCoordinates.width / this.config.originalImageWidth;
        var resizeRatioH = this.cropCoordinates.height / this.config.originalImageHeight;
        var resizeRatio = ((this.config.resizeMode === 0 && resizeRatioH < resizeRatioW) ||
            (this.config.resizeMode === 1 && resizeRatioH > resizeRatioW)
            ? resizeRatioH
            : resizeRatioW);
        var top = this.cropareaBorderWidth +
            this.cropCoordinates.top +
            ((this.cropCoordinates.height) - (this.config.originalImageHeight * resizeRatio)) / 2;
        var left = this.cropareaBorderWidth +
            this.cropCoordinates.left +
            ((this.cropCoordinates.width) - (this.config.originalImageWidth * resizeRatio)) / 2;
        this.$imageobj.css("width", this.config.originalImageWidth * resizeRatio)
            .css("height", this.config.originalImageHeight * resizeRatio).css("left", left).css("top", top);
        this.zoomLevel = 100 * resizeRatio;
        this.originalZoomLevel = this.zoomLevel;
    };
    ImageEditor.prototype.zoomImage = function (delta, zoomLevel) {
        return this.zoomImageInternal(delta, zoomLevel);
    };
    ImageEditor.prototype.updateCurrentEffects = function () {
        var effectArray = [];
        this.cropCoordinates.leftFromImage = Math
            .round((this.$outline.position().left + this.cropareaBorderWidth - this.$imageobj.position().left) *
            this.cropCoordinates.scale);
        this.cropCoordinates.topFromImage = Math
            .round((this.$outline.position().top + this.cropareaBorderWidth - this.$imageobj.position().top) *
            this.cropCoordinates.scale);
        var cropWidth = Math.round(this.cropCoordinates.unscaledWidth > this.config.originalImageWidth
            ? this.config.originalImageWidth
            : this.cropCoordinates.unscaledWidth);
        var cropHeight = Math.round(this.cropCoordinates.unscaledHeight > this.config.originalImageHeight
            ? this.config.originalImageHeight
            : this.cropCoordinates.unscaledHeight);
        var resizeWidth = Math.round(this.config.originalImageWidth *
            (this.zoomLevel / 100) *
            this.cropCoordinates.scale);
        var resizeHeight = Math.round(this.config.originalImageHeight *
            (this.zoomLevel / 100) *
            this.cropCoordinates.scale);
        if (resizeWidth > this.config.originalImageWidth)
            resizeWidth = this.config.originalImageWidth;
        if (resizeHeight > this.config.originalImageHeight)
            resizeHeight = this.config.originalImageHeight;
        effectArray.push(new effects_1.ResizeEffect(resizeWidth, resizeHeight, 0));
        effectArray.push(new effects_1.CropEffect(this.cropCoordinates.leftFromImage, this.cropCoordinates.topFromImage, cropWidth, cropHeight));
        try {
            effectArray.push(this.config.getCurrentExportMetadataEffect());
        }
        catch (e) { }
        this.config.currentEffects = effectArray;
    };
    ImageEditor.prototype.updateWidthAndHeightControls = function () {
        this.oldImageWidthCtrlValue = Math.round(this.cropCoordinates.unscaledWidth);
        this.oldImageHeightCtrlValue = Math.round(this.cropCoordinates.unscaledHeight);
        this.$inputImageWidth.val(this.oldImageWidthCtrlValue);
        this.$inputImageHeight.val(this.oldImageHeightCtrlValue);
        if (this.cropCoordinates.scale > 1) {
            this.$cropWarningImage.show();
        }
        else {
            this.$cropWarningImage.hide();
            this.$reloadEditorButton.hide();
        }
    };
    ImageEditor.prototype.applyWidth = function (input) {
        var newNum = parseInt($(input).val());
        if (!newNum || newNum === this.oldImageWidthCtrlValue) {
            $(input).val(this.oldImageWidthCtrlValue);
            return;
        }
        if (this.config.keepAspectRatio) {
            var aspectRatio = this.cropCoordinates.width / this.cropCoordinates.height;
            var newHeight = newNum / aspectRatio;
            $("input#image-height").val(newHeight);
            this.adjustCropAreaAndImage({ width: newNum, height: newHeight });
            return;
        }
        this.adjustCropAreaAndImage({ width: newNum });
    };
    ImageEditor.prototype.applyHeight = function (input) {
        var newNum = parseInt($(input).val());
        if (!newNum || newNum === this.oldImageHeightCtrlValue) {
            $(input).val(this.oldImageHeightCtrlValue);
            return;
        }
        if (this.config.keepAspectRatio) {
            var aspectRatio = this.cropCoordinates.width / this.cropCoordinates.height;
            var newWidth = newNum * aspectRatio;
            $("input#image-width").val(newWidth);
            this.adjustCropAreaAndImage({ width: newWidth, height: newNum });
            return;
        }
        this.adjustCropAreaAndImage({ height: newNum });
    };
    ImageEditor.prototype.setSizeAndCenterImageInCropArea = function (self) {
        var width;
        var height;
        width = self.config.originalImageWidth * (self.zoomLevel / 100);
        height = width / self.aspectRatio;
        var cw = self.cropCoordinates.width;
        var ch = self.cropCoordinates.height;
        if ((self.config.resizeMode === 0 && width < cw && height < ch) ||
            (self.config.resizeMode === 1 && (width < cw || height < ch))) {
            var diffw = width - cw;
            var diffh = height - ch;
            if ((self.config.resizeMode === 0 && diffw > diffh) || (self.config.resizeMode === 1 && diffw < diffh)) {
                width = cw;
                height = width / self.aspectRatio;
            }
            else {
                height = ch;
                width = height * self.aspectRatio;
            }
        }
        var mx = self.$outline.offset().left + self.$outline.width() / 2 - self.$imageobj.offset().left;
        var my = self.$outline.offset().top + self.$outline.height() / 2 - self.$imageobj.offset().top;
        var outerImagePosition = self.$imageobj.position();
        var owidth = self.$imageobj.width();
        var oheight = self.$imageobj.height();
        var ix = outerImagePosition.left;
        var iy = outerImagePosition.top;
        var x = ix + (mx / owidth) * (owidth - width);
        var y = iy + (my / oheight) * (oheight - height);
        if (x > self.cropCoordinates.left) {
            x = self.cropCoordinates.left + self.cropareaBorderWidth;
        }
        if (y > self.cropCoordinates.top) {
            y = self.cropCoordinates.top + self.cropareaBorderWidth;
        }
        if (y + height < self.cropCoordinates.top + self.cropCoordinates.height + self.cropareaBorderWidth) {
            y = self.cropareaBorderWidth + self.cropCoordinates.top + self.cropCoordinates.height - height;
        }
        if (x + width < self.cropCoordinates.left + self.cropCoordinates.width + self.cropareaBorderWidth) {
            x = self.cropareaBorderWidth + self.cropCoordinates.left + self.cropCoordinates.width - width;
        }
        if (width < self.cropCoordinates.width) {
            x = self.cropCoordinates.left + self.cropareaBorderWidth + ((self.cropCoordinates.width) - width) / 2;
        }
        if (height < self.cropCoordinates.height) {
            y = self.cropCoordinates.top + self.cropareaBorderWidth + ((self.cropCoordinates.height) - height) / 2;
        }
        if (self.config.nodeInfo && self.config.resizeMode === 0) {
            if (width < self.cropCoordinates.width) {
                x = self.cropCoordinates.left + self.cropareaBorderWidth;
            }
            if (height < self.cropCoordinates.height) {
                y = self.cropCoordinates.top + self.cropareaBorderWidth;
            }
        }
        self.$imageobj.css("width", width).css("height", height);
        self.$imageobj.css("left", x).css("top", y);
        self.setSelectionImage();
    };
    ImageEditor.prototype.positionResizeHandle = function ($handle, position, display) {
        var hw = $handle.width();
        var hh = $handle.height();
        var left = this.cropCoordinates.left - (hw + this.cropareaBorderWidth) / 2;
        var top = this.cropCoordinates.top - (hh + this.cropareaBorderWidth) / 2;
        switch (position) {
            case "n-resize":
            case "s-resize":
                left += this.cropCoordinates.width / 2;
                break;
            case "ne-resize":
            case "e-resize":
            case "se-resize":
                left += this.cropCoordinates.width;
                break;
        }
        switch (position) {
            case "w-resize":
            case "e-resize":
                top += this.cropCoordinates.height / 2;
                break;
            case "sw-resize":
            case "s-resize":
            case "se-resize":
                top += this.cropCoordinates.height;
                break;
        }
        $handle.css({
            cursor: position,
            display: display,
            left: left,
            top: top
        });
    };
    ImageEditor.prototype.updateResizeHandlers = function (action) {
        switch (action) {
            case "hide-all":
                $(".image-crop-resize-handler").each(function () {
                    $(this).css({
                        display: "none"
                    });
                });
                break;
            default:
                var displayCorners = (!this.config.propertyHeight && !this.config.propertyWidth) ? "block" : "none";
                var displayHorizontal = (!this.config.propertyHeight && !this.config.keepAspectRatio) ? "block" : "none";
                var displayVertical = (!this.config.propertyWidth && !this.config.keepAspectRatio) ? "block" : "none";
                this.positionResizeHandle(this.$nwResizeHandler, "nw-resize", displayCorners);
                this.positionResizeHandle(this.$nResizeHandler, "n-resize", displayHorizontal);
                this.positionResizeHandle(this.$neResizeHandler, "ne-resize", displayCorners);
                this.positionResizeHandle(this.$wResizeHandler, "w-resize", displayVertical);
                this.positionResizeHandle(this.$eResizeHandler, "e-resize", displayVertical);
                this.positionResizeHandle(this.$swResizeHandler, "sw-resize", displayCorners);
                this.positionResizeHandle(this.$sResizeHandler, "s-resize", displayHorizontal);
                this.positionResizeHandle(this.$seResizeHandler, "se-resize", displayCorners);
        }
    };
    ImageEditor.prototype.registerEvents = function () {
        var self = this;
        $(document).unbind("keydown");
        if (this.$workspace != undefined)
            this.$workspace.unbind("keydown");
        $(document).keydown(keydownEvents);
        this.$workspace.keydown(keydownEvents);
        if (window.navigator.userAgent.indexOf("MSIE") !== -1)
            $(".ui-slider-handle").unbind("keydown");
        this.$workspace.mousewheel(function (event, delta) {
            event = $.event.fix(event);
            event.preventDefault();
            event.stopPropagation();
            self.zoomImageInternal(delta, null);
            self.$slider.slider("value", self.zoomLevel);
        });
        this.$outline.mousedown(function () {
            $(document).mousemove(function (e) {
                moveImage(e, null, null);
            });
            $(document).mouseup(releaseEvents);
        });
        this.$reloadEditorButton.click(function () {
            self.updateCurrentEffects();
            self.updateEffects(self.config.currentEffects);
            self.$reloadEditorButton.hide();
            return false;
        });
        this.firstTime = true;
        this.$workspace.mousedown(function () {
            $(document).mousemove(function (e) {
                moveImage(e, null, null);
            });
            $(document).mouseup(releaseEvents);
            if (self.firstTime) {
                self.firstTime = false;
                if (window.navigator.userAgent.indexOf("MSIE") === -1) {
                    return true;
                }
            }
            return false;
        });
        this.$slider.mouseup(function (e) {
            e = $.event.fix(e);
            self.firstTime = true;
            e.preventDefault();
        });
        $(".image-crop-resize-handler").mousedown(function (e) {
            e = $.event.fix(e);
            e.preventDefault();
            e.stopPropagation();
            $(document).mousemove(resizeCropArea);
            $(document).mouseup(releaseEvents);
            self.currentHandle = e.target.id;
            self.updateResizeHandlers("hide-all");
            updateCursor($(e.target).css("cursor"));
            return false;
        });
        if (!this.config.propertyWidth) {
            this.$inputImageWidth.blur(function () {
                self.applyWidth(this);
            });
            this.$inputImageWidth.focus(function () {
                self.oldImageWidthCtrlValue = parseInt($(this).val());
            });
            this.$inputImageWidth.keydown(function (e) {
                if (e.which === 13 || ($.browser.opera && e.which === 9)) {
                    self.applyWidth(this);
                }
                return true;
            });
        }
        else {
            this.$inputImageWidth.attr("readonly", "readonly");
            this.$inputImageWidth.keydown(function (e) {
                if (e.which === 8) {
                    return false;
                }
                return true;
            });
        }
        if (!this.config.propertyHeight) {
            this.$inputImageHeight.blur(function () {
                self.applyHeight(this);
            });
            this.$inputImageHeight.focus(function () {
                self.oldImageHeightCtrlValue = parseInt($(this).val());
            });
            this.$inputImageHeight.keydown(function (e) {
                if (e.which === 13 || ($.browser.opera && e.which === 9)) {
                    self.applyHeight(this);
                }
                return true;
            });
        }
        else {
            this.$inputImageHeight.attr("readonly", "readonly");
            this.$inputImageHeight.keydown(function (e) {
                if (e.which === 8) {
                    return false;
                }
                return true;
            });
        }
        function releaseEvents(event) {
            event = $.event.fix(event);
            event.preventDefault();
            event.stopPropagation();
            $(document).unbind("mousemove");
            $(document).unbind("mouseup");
            self.mouseY = 0;
            self.mouseX = 0;
            self.updateResizeHandlers(null);
            updateCursor("pointer");
        }
        if (this.config.propertyHeight || this.config.propertyWidth) {
            this.$keepAspectRatioButton.addClass("disabled");
            this.updateKeepAspectRatio(this.config.propertyHeight && this.config.propertyWidth);
        }
        else {
            this.$keepAspectRatioButton.removeClass("disabled");
        }
        function keydownEvents(e) {
            e = $.event.fix(e);
            var keyCode = e.keyCode || e.which;
            var key = { left: 37, up: 38, right: 39, down: 40, escape: 27 };
            if (!self.firstTime) {
                switch (keyCode) {
                    case key.left:
                        e.preventDefault();
                        e.stopPropagation();
                        moveImage(null, -1, 0);
                        break;
                    case key.up:
                        e.preventDefault();
                        e.stopPropagation();
                        moveImage(null, 0, -1);
                        break;
                    case key.right:
                        e.preventDefault();
                        e.stopPropagation();
                        moveImage(null, 1, 0);
                        break;
                    case key.down:
                        e.preventDefault();
                        e.stopPropagation();
                        moveImage(null, 0, 1);
                        break;
                    case key.escape:
                        $("#cancel-editor").click();
                        break;
                }
            }
            else {
                switch (keyCode) {
                    case key.left:
                    case key.up:
                    case key.right:
                    case key.down:
                        e.preventDefault();
                        e.stopPropagation();
                        break;
                }
            }
        }
        function resizeCropArea(e) {
            e = $.event.fix(e);
            e.preventDefault();
            e.stopPropagation();
            var mouseposition = getMousePosition(e);
            var oldLeft;
            var oldTop;
            var oldRight;
            var xDelta;
            var x = mouseposition[0];
            var y = mouseposition[1];
            switch (self.currentHandle) {
                case "image-crop-nw-resize-handler":
                    if (x >= self.cropCoordinates.width)
                        x = self.cropCoordinates.width - 1;
                    if (y >= self.cropCoordinates.height)
                        y = self.cropCoordinates.height - 1;
                    oldLeft = self.cropCoordinates.left;
                    oldTop = self.cropCoordinates.top;
                    oldRight = self.cropCoordinates.left + self.cropCoordinates.width;
                    self.cropCoordinates.height = self.cropCoordinates.height - y;
                    self.cropCoordinates.width = (self.config.keepAspectRatio)
                        ? self.cropCoordinates.height * self.cropAspectRatio
                        : self.cropCoordinates.width - x;
                    self.cropCoordinates.top = y + oldTop;
                    xDelta = (oldRight - self.cropCoordinates.width) - oldLeft;
                    self.cropCoordinates.left = self.cropCoordinates.left + xDelta;
                    break;
                case "image-crop-n-resize-handler":
                    if (y >= self.cropCoordinates.height)
                        y = self.cropCoordinates.height - 1;
                    oldTop = self.cropCoordinates.top;
                    self.cropCoordinates.top = y + oldTop;
                    self.cropCoordinates.height = self.cropCoordinates.height - y;
                    break;
                case "image-crop-ne-resize-handler":
                    if (x < 1)
                        x = 1;
                    if (y >= self.cropCoordinates.height)
                        y = self.cropCoordinates.height - 1;
                    oldTop = self.cropCoordinates.top;
                    self.cropCoordinates.top = y + oldTop;
                    self.cropCoordinates.height = self.cropCoordinates.height - y;
                    self.cropCoordinates.width = (self.config.keepAspectRatio)
                        ? self.cropCoordinates.height * self.cropAspectRatio
                        : x;
                    break;
                case "image-crop-w-resize-handler":
                    if (x >= self.cropCoordinates.width)
                        x = self.cropCoordinates.width - 1;
                    oldLeft = self.cropCoordinates.left;
                    self.cropCoordinates.left = x + oldLeft;
                    self.cropCoordinates.width = self.cropCoordinates.width - x;
                    break;
                case "image-crop-e-resize-handler":
                    if (x < 1)
                        x = 1;
                    self.cropCoordinates.width = x;
                    break;
                case "image-crop-sw-resize-handler":
                    if (x >= self.cropCoordinates.width)
                        x = self.cropCoordinates.width - 1;
                    if (y < 1)
                        y = 1;
                    oldRight = self.cropCoordinates.left + self.cropCoordinates.width;
                    oldLeft = self.cropCoordinates.left;
                    self.cropCoordinates.height = y;
                    self.cropCoordinates.width = (self.config.keepAspectRatio)
                        ? self.cropCoordinates.height * self.cropAspectRatio
                        : self.cropCoordinates.width - x;
                    xDelta = (oldRight - self.cropCoordinates.width) - oldLeft;
                    self.cropCoordinates.left = self.cropCoordinates.left + xDelta;
                    self.$selectionImage.css("left", self.$selectionImage.cssVal("left") - xDelta);
                    break;
                case "image-crop-s-resize-handler":
                    if (y < 1)
                        y = 1;
                    self.cropCoordinates.height = y;
                    break;
                case "image-crop-se-resize-handler":
                    if (x < 1)
                        x = 1;
                    if (y < 1)
                        y = 1;
                    self.cropCoordinates.height = y;
                    self.cropCoordinates.width = x;
                    self.cropCoordinates.width = (self.config.keepAspectRatio)
                        ? self.cropCoordinates.height * self.cropAspectRatio
                        : x;
                    break;
            }
            self.cropCoordinates.unscaledHeight = Math.round(self.cropCoordinates.height * self.cropCoordinates.scale);
            self.cropCoordinates.unscaledWidth = Math.round(self.cropCoordinates.width * self.cropCoordinates.scale);
            if (self.cropCoordinates
                .unscaledHeight >
                self.config.originalImageHeight)
                self.cropCoordinates.unscaledHeight = self.config.originalImageHeight;
            if (self.cropCoordinates
                .unscaledWidth >
                self.config.originalImageWidth)
                self.cropCoordinates.unscaledWidth = self.config.originalImageWidth;
            self.updateWidthAndHeightControls();
            self.resizeCropArea(self.cropCoordinates);
            if (self.cropCoordinates.scale > 1) {
                self.$reloadEditorButton.show();
                self.$reloadEditorButton.blur();
            }
            else {
                self.$reloadEditorButton.hide();
            }
        }
        ;
        function getOffsetPosition(target) {
            var offset = target.offset();
            var top = offset.top;
            var left = offset.left;
            var bottom = $(window).height() - target.outerHeight();
            bottom = offset.top - bottom;
            var right = $(window).width() - target.outerWidth();
            right = offset.left - right;
            var k = {
                bottom: $(window).height() + bottom,
                right: $(window).width() + right,
                top: top,
                left: left
            };
            return k;
        }
        ;
        function getMousePosition(event) {
            var workspace = getOffsetPosition(self.$workspace);
            var imageobj = getOffsetPosition(self.$imageobj);
            var outline = getOffsetPosition(self.$outline);
            var x = event.pageX - outline.left, y = event.pageY - outline.top;
            if ((Math.round(outline.top) + y < Math.round(imageobj.top - self.cropareaBorderWidth)) && y <= 0)
                y = Math.round(imageobj.top - self.cropareaBorderWidth) - Math.round(outline.top);
            if ((Math.round(outline.top) + y < Math.round(workspace.top)) && y <= 0)
                y = Math.round(workspace.top) - Math.round(outline.top);
            if (y > Math.round(imageobj.bottom - self.cropareaBorderWidth) - Math.round(outline.top))
                y = Math.round(imageobj.bottom - self.cropareaBorderWidth) - Math.round(outline.top);
            if (y > Math.round(workspace.bottom - 2 * self.cropareaBorderWidth) - Math.round(outline.top))
                y = Math.round(workspace.bottom - 2 * self.cropareaBorderWidth) - Math.round(outline.top);
            if ((Math.round(outline.left) + x < Math.round(imageobj.left - self.cropareaBorderWidth)) && x <= 0)
                x = Math.round(imageobj.left - self.cropareaBorderWidth) - Math.round(outline.left);
            if ((Math.round(outline.left) + x < Math.round(workspace.left)) && x <= 0)
                x = Math.round(workspace.left) - Math.round(outline.left);
            if (x > Math.round(imageobj.right - self.cropareaBorderWidth) - Math.round(outline.left))
                x = Math.round(imageobj.right - self.cropareaBorderWidth) - Math.round(outline.left);
            if (x > Math.round(workspace.right - 2 * self.cropareaBorderWidth) - Math.round(outline.left))
                x = Math.round(workspace.right - 2 * self.cropareaBorderWidth) - Math.round(outline.left);
            return [x, y];
        }
        ;
        function updateCursor(cursorType) {
            self.$workspace.css({
                cursor: cursorType
            });
            self.$outline.css({
                cursor: cursorType
            });
            self.$selection.css({
                cursor: cursorType
            });
            self.$slider.css({
                cursor: cursorType
            });
        }
        ;
        function moveImage(e, dx, dy) {
            var imageWidth = self.$imageobj.width();
            var imageHeight = self.$imageobj.height();
            if (self.cropCoordinates.width === imageWidth && self.cropCoordinates.height === imageHeight)
                return false;
            if (e) {
                dx = (self.mouseX === 0) ? 0 : e.pageX - self.mouseX;
                dy = (self.mouseY === 0) ? 0 : e.pageY - self.mouseY;
            }
            var outerImagePosition = self.$imageobj.position();
            var newLeft = outerImagePosition.left + dx;
            var newTop = outerImagePosition.top + dy;
            if (dx !== 0) {
                if (newLeft > self.cropCoordinates.left + self.cropareaBorderWidth)
                    newLeft = self.cropCoordinates.left + self.cropareaBorderWidth;
                if (newLeft + imageWidth <
                    self.cropCoordinates.left + self.cropCoordinates.width + self.cropareaBorderWidth)
                    newLeft = self.cropCoordinates.left +
                        self.cropCoordinates.width -
                        imageWidth +
                        self.cropareaBorderWidth;
                if (self.cropCoordinates.width > imageWidth)
                    newLeft = outerImagePosition.left;
                self.$imageobj.css("left", newLeft);
            }
            if (dy !== 0) {
                if (newTop > self.cropCoordinates.top + self.cropareaBorderWidth)
                    newTop = self.cropCoordinates.top + self.cropareaBorderWidth;
                if (newTop + imageHeight <
                    self.cropCoordinates.top + self.cropCoordinates.height + self.cropareaBorderWidth)
                    newTop = self.cropCoordinates.top +
                        self.cropCoordinates.height -
                        imageHeight +
                        self.cropareaBorderWidth;
                if (self.cropCoordinates.height > imageHeight)
                    newTop = outerImagePosition.top;
                self.$imageobj.css("top", newTop);
            }
            if (e) {
                self.mouseX = e.pageX;
                self.mouseY = e.pageY;
            }
            self.setSelectionImageEvent();
            return true;
        }
    };
    ImageEditor.prototype.zoomImageInternal = function (delta, zoomLevel) {
        var oldZoom = Math.round(this.zoomLevel * 1000) / 1000;
        this.$slider.slider("value", zoomLevel);
        if (zoomLevel != null) {
            this.zoomLevel = zoomLevel;
        }
        else {
            this.zoomLevel += Math.round((this.zoomLevel * this.step / 100 * delta) * 1000) / 1000;
        }
        if (this.zoomLevel >= Math.round((100 / this.cropCoordinates.scale) * 1000) / 1000) {
            this.zoomLevel = Math.round((100 / this.cropCoordinates.scale) * 1000) / 1000;
            this.$slider.slider("option", "max", this.zoomLevel);
            this.$slider.slider("value", this.zoomLevel);
        }
        if (this.zoomLevel < this.originalZoomLevel)
            this.zoomLevel = Math.round((this.originalZoomLevel * 1000)) / 1000;
        if (oldZoom === this.zoomLevel) {
            return false;
        }
        this.setSizeAndCenterImageInCropArea(this);
        return true;
    };
    ImageEditor.prototype.adjustCropAreaAndImage = function (size) {
        this.updateCurrentEffects();
        var cropEffect = this.config.getCurrentCropEffect();
        var resizeEffect = this.config.getCurrentResizeEffect();
        cropEffect.Width = this.adjustRange(size.width || this.oldImageWidthCtrlValue, 10, this.config.originalImageWidth);
        cropEffect.Height = this.adjustRange(size.height || this.oldImageHeightCtrlValue, 10, this.config.originalImageHeight);
        var centerX = (cropEffect.X + this.oldImageWidthCtrlValue / 2) / resizeEffect.Width;
        var centerY = (cropEffect.Y + this.oldImageHeightCtrlValue / 2) / resizeEffect.Height;
        var needsResize = false;
        if (cropEffect.Width + cropEffect.X > resizeEffect.Width) {
            if (cropEffect.X < (cropEffect.Width - this.oldImageWidthCtrlValue)) {
                needsResize = true;
            }
        }
        if (cropEffect.Height + cropEffect.Y > resizeEffect.Height) {
            if (cropEffect.Y < (cropEffect.Height - this.oldImageHeightCtrlValue)) {
                needsResize = true;
            }
        }
        if (needsResize) {
            var scaleX = cropEffect.Width * 1.1 / this.config.originalImageWidth;
            var scaleY = cropEffect.Height * 1.1 / this.config.originalImageWidth;
            var scale = scaleX > scaleY ? scaleX : scaleY;
            scale = scale > 1 ? 1 : scale;
            resizeEffect.Width = scale * this.config.originalImageWidth;
            resizeEffect.Height = scale * this.config.originalImageHeight;
        }
        cropEffect.X = 0;
        cropEffect.Y = 0;
        if (cropEffect.Width < resizeEffect.Width) {
            cropEffect.X = this.adjustRange(centerX * resizeEffect.Width - cropEffect.Width / 2, 0, (resizeEffect.Width - cropEffect.Width));
        }
        if (cropEffect.Height < resizeEffect.Height) {
            cropEffect.Y = this.adjustRange(centerY * resizeEffect.Height - cropEffect.Height / 2, 0, (resizeEffect.Height - cropEffect.Height));
        }
        this.cropCoordinates.scale = 1;
        var effects = [];
        effects.push(resizeEffect);
        effects.push(cropEffect);
        this.config.currentEffects = effects;
        this.updateEffects(this.config.currentEffects);
        this.updateWidthAndHeightControls();
    };
    ImageEditor.prototype.adjustRange = function (value, min, max) {
        if (value < min)
            return min;
        if (value > max)
            return max;
        return value;
    };
    return ImageEditor;
}());
exports.ImageEditor = ImageEditor;
;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-video-editor.ts":
/*!********************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-video-editor.ts ***!
  \********************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.VideoEditor = void 0;
var JQuery = __webpack_require__(/*! jquery */ "jquery");
var effects_1 = __webpack_require__(/*! ./effects */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts");
var formats_1 = __webpack_require__(/*! ./formats */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts");
var $ = window.iv_jQuery != undefined ? window.iv_jQuery : JQuery;
var VideoEditor = (function () {
    function VideoEditor(config) {
        var _this = this;
        this.editableMediaUrl = null;
        this.editableMediaContentType = null;
        this.editableMediaWebmUrl = null;
        this.editableMediaWebmContentType = null;
        $(".editor-title").text(config.title);
        config.title = config.title !== undefined ? config.title : "Edit video";
        var self = this;
        self.config = config;
        var videoEffects = [];
        if (this.config.currentEffects && this.config.currentEffects.length > 0) {
            videoEffects = this.config.currentEffects.filter(function (e) {
                return e.$type.indexOf("ImageVault.Common.Data.Effects.TrimEffect,") > -1;
            }).map(function (eff) {
                var te = eff;
                if (!te.Start) {
                    te.Start = 0;
                }
                return te;
            });
        }
        self.setupDom();
        this.loadEditableMedia(function () {
            if (videoEffects.length > 0) {
                _this.setupVideoTag($(videoEffects).get(-1).Start, $(videoEffects).get(-1).Stop);
            }
            else {
                _this.setupVideoTag(0, -1);
            }
        });
    }
    VideoEditor.prototype.initPlayerDone = function () {
        this.config.$preloadobj.fadeOut(400);
    };
    VideoEditor.prototype.setupDom = function () {
        $('<div id="player1" class="player">' +
            '<div id="canvas">' +
            '<canvas id="myCanvas">' +
            "Your browser does not support the HTML5 canvas tag." +
            "</canvas>" +
            "</div>" +
            '<div id="editor-buttons-area-container">' +
            '<div id="editor-buttons-area">' +
            '<div class="control-area video-control-area">' +
            "</div>" +
            '<div id="editor-actions" class="video-actions">' +
            '<a id="save-editor" href="#" class="propertymedia-btn save-button">' + this.config.editorOkButtonText + "</a>" +
            '<a id="cancel-editor" href="#" class="propertymedia-btn cancel-button">' + this.config.editorCancelButtonText + "</a>" +
            "</div>" +
            "</div>" +
            "</div>" +
            "</div>").appendTo("#editor");
    };
    VideoEditor.prototype.setupVideoTag = function (start, stop) {
        $("#player1").prepend('<div id="video">' +
            '<video class="video" id="myVideo" onloadedmetadata="videoPlayer = ImageVault.VideoEditor2.initPlayer(\'myVideo\', \'myCanvas\', {start:' +
            start +
            ", stop:" +
            stop +
            ', editor: true}); $(\'#preloading\').hide();">' +
            '<source src="' +
            this.editableMediaUrl +
            '" type="' +
            this.editableMediaContentType +
            '">' +
            '<source src="' +
            this.editableMediaWebmUrl +
            '" type="' +
            this.editableMediaWebmContentType +
            '">' +
            "Your browser does not support the video tag." +
            "</video>" +
            "</div>");
    };
    VideoEditor.prototype.loadEditableMedia = function (callback) {
        var self = this;
        var parameters = {
            Filter: { Id: [this.config.imageId] },
            Populate: {
                MediaFormats: [
                    new formats_1.WebMediaFormat([new effects_1.ChangeOutputFormatEffect("video/mp4")]),
                    new formats_1.WebMediaFormat([new effects_1.ChangeOutputFormatEffect("video/webm")])
                ]
            },
            MediaUrlBase: this.config.mediaUrlBase
        };
        var json = JSON.stringify(parameters);
        self.config.executeActionWithRetryAndInformOnPreload(function (retryLogic) {
            self.config.client.json("MediaService/Find", json, function (x) {
                if (x == null) {
                    if (!retryLogic.retry()) {
                        self.config.callback(null);
                    }
                    return;
                }
                self.editableMediaUrl = self.config.addAssetUrlParameters(x[0].MediaConversions[0].Url);
                self.editableMediaWebmUrl = self.config.addAssetUrlParameters(x[0].MediaConversions[1].Url);
                self.editableMediaContentType = x[0].MediaConversions[0].ContentType;
                self.editableMediaWebmContentType = x[0].MediaConversions[1].ContentType;
                callback();
            });
        });
    };
    VideoEditor.prototype.updateCurrentEffects = function () {
        var effectArray = [];
        effectArray.push(new effects_1.ChangeOutputFormatEffect("video/mp4"));
        var videoPlayer = window.videoPlayer;
        var timeStart = videoPlayer.getStartTime();
        var timeStop = videoPlayer.getStopTime();
        if (timeStart !== 0 || timeStop !== videoPlayer.getVideoDuration()) {
            effectArray.push(new effects_1.TrimEffect(timeStart, timeStop));
        }
        var config = this.config;
        if (config.propertyWidth || config.propertyHeight) {
            effectArray.push(new effects_1.ResizeEffect(config.propertyWidth, config.propertyHeight, config.resizeMode));
        }
        config.currentEffects = effectArray;
    };
    return VideoEditor;
}());
exports.VideoEditor = VideoEditor;
;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/AmpTrimPlugin.ts":
/*!****************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/AmpTrimPlugin.ts ***!
  \****************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AmpIvTrimPlugin = void 0;
var $ = __webpack_require__(/*! jquery */ "jquery");
var effects_1 = __webpack_require__(/*! ../effects */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts");
var AmpIvTrimPlugin = exports.AmpIvTrimPlugin = (function () {
    function AmpIvTrimPlugin(player, options) {
        var _this = this;
        this.currentDrag = DragTrimHandleType.None;
        this.options = options;
        this.player = player;
        var pauseAtEndInterval = null;
        player.addEventListener(amp.eventName.play, function () {
            var currentTrim = _this.getCurrentTrimEffect();
            var currentTime = _this.player.currentTime() + 0.2;
            if (currentTime >= currentTrim.Stop) {
                _this.player.currentTime(currentTrim.Start);
            }
            if (pauseAtEndInterval)
                clearInterval(pauseAtEndInterval);
            pauseAtEndInterval = setInterval(function () { _this.pauseAtEnd(); }, 100);
        });
        player.addEventListener(amp.eventName.pause, function () {
            if (pauseAtEndInterval)
                clearInterval(pauseAtEndInterval);
            pauseAtEndInterval = null;
        });
        player.addEventListener(amp.eventName.loadeddata, function () {
            var $player = $(".ivAmp-editor");
            _this.$progressControl = $(".vjs-progress-control", $player);
            var $progressHolder = $(".vjs-progress-holder", _this.$progressControl);
            $("<div class='ivAmpEditor-trim-fill-left'></div><div class='ivAmpEditor-trim-area'><div class='ivAmpEditor-trim-cursor-left'>&lt;&gt;<div class='time-holder'></div></div><div class='ivAmpEditor-trim-cursor-right'>&lt;&gt;<div class='time-holder'></div></div></div><div class='ivAmpEditor-trim-fill-right'></div>").appendTo($progressHolder);
            _this.$trimArea = $(".ivAmpEditor-trim-area", $progressHolder);
            _this.$trimFillLeft = $(".ivAmpEditor-trim-fill-left", $progressHolder);
            _this.$trimFillRight = $(".ivAmpEditor-trim-fill-right", $progressHolder);
            _this.$trimCursorLeft = $(".ivAmpEditor-trim-cursor-left", _this.$trimArea);
            _this.$trimCursorRight = $(".ivAmpEditor-trim-cursor-right", _this.$trimArea);
            _this.$timeHolderLeft = $(".time-holder", _this.$trimCursorLeft);
            _this.$timeHolderRight = $(".time-holder", _this.$trimCursorRight);
            _this.$playProgress = $(".vjs-play-progress", _this.$progressControl);
            _this.setStart(_this.options.start || 0);
            _this.setStop(_this.options.stop || _this.player.duration());
            _this.$trimCursorLeft.mousedown(function (e) {
                e.stopPropagation();
                _this.dragOffset = e.clientX - _this.$trimCursorLeft.offset().left;
                _this.dragStart(DragTrimHandleType.Left);
                return false;
            });
            _this.$trimCursorRight.mousedown(function (e) {
                e.stopPropagation();
                _this.dragOffset = _this.$trimCursorRight.offset().left - e.clientX;
                _this.dragStart(DragTrimHandleType.Right);
                return false;
            });
            $(document).mouseup(function () { _this.dragStop(); });
            $(document).mouseleave(function () { _this.dragStop(); });
            $(document).mousemove(function (e) {
                if (_this.currentDrag == DragTrimHandleType.None)
                    return;
                var pl = _this.$progressControl.offset().left;
                var pw = _this.$progressControl.width();
                var p = (e.clientX + _this.dragOffset - pl) * 1.0 / pw;
                if (p < 0)
                    p = 0;
                if (p > 1)
                    p = 1;
                if (_this.currentDrag == DragTrimHandleType.Left) {
                    var right = (_this.$trimArea.position().left + _this.$trimArea.width()) * 1.0 / pw;
                    var left = (_this.$trimArea.position().left) * 1.0 / pw;
                    if (p > right)
                        p = right;
                    var startTime = _this.setLeftPosition(p);
                    left = (_this.$trimArea.position().left) * 1.0 / pw;
                    if (left > right) {
                        _this.setStop(startTime + 0.1);
                    }
                    var playerCurrentTime = _this.player.currentTime();
                    if (Math.abs(playerCurrentTime - startTime) > 0.001)
                        _this.player.currentTime(startTime);
                }
                else {
                    var left = (_this.$trimArea.position().left) * 1.0 / pw;
                    if (p < left)
                        p = left;
                    var right = p * pw;
                    _this.setRightPosition(p);
                }
            });
        });
    }
    AmpIvTrimPlugin.prototype.formatSeconds = function (seconds) {
        var minutes = 0;
        if (seconds > 60) {
            minutes = Math.floor(seconds / 60);
            seconds = seconds % 60;
        }
        seconds = Math.round(seconds * 10) / 10;
        return minutes + ":" + (seconds < 10 ? "0" : "") + seconds;
    };
    AmpIvTrimPlugin.prototype.setLeftPosition = function (p) {
        var seconds = this.player.duration() * p;
        return this.setStart(seconds);
    };
    AmpIvTrimPlugin.prototype.snapToKeyFrame = function (seconds) {
        if (!this.options.keyFrames || !this.options.keyFrames.length)
            return seconds;
        var closestKeyFrame = 0;
        var closestDiff = seconds;
        for (var i = 0; i < this.options.keyFrames.length; i++) {
            var kf = this.options.keyFrames[i];
            var diff = Math.abs(seconds - kf);
            if (diff < closestDiff) {
                closestKeyFrame = kf;
                closestDiff = diff;
            }
            if (kf > seconds)
                break;
        }
        return closestKeyFrame;
    };
    AmpIvTrimPlugin.prototype.setStart = function (seconds) {
        seconds = this.snapToKeyFrame(seconds);
        var p = seconds / this.player.duration();
        this.$trimArea.css("left", (p * 100) + "%");
        this.$trimFillLeft.css("right", (100 - (p * 100)) + "%");
        this.$timeHolderLeft.text(this.formatSeconds(seconds));
        var gradient = "linear-gradient(to right, #9c9e9f " + this.$trimArea.position().left + "px, #71b1d1 " + this.$trimArea.position().left + "px)";
        this.$playProgress.css("background", gradient);
        return seconds;
    };
    AmpIvTrimPlugin.prototype.setRightPosition = function (p) {
        var seconds = this.player.duration() * p;
        return this.setStop(seconds, true);
    };
    AmpIvTrimPlugin.prototype.setStop = function (seconds, setTime) {
        seconds = this.snapToKeyFrame(seconds);
        var p = seconds / this.player.duration();
        this.$trimArea.css("right", (100 - (p * 100)) + "%");
        this.$trimFillRight.css("left", (p * 100) + "%");
        this.$timeHolderRight.text(this.formatSeconds(seconds));
        if (setTime)
            this.player.currentTime(seconds);
        return seconds;
    };
    AmpIvTrimPlugin.prototype.log = function (message) {
        if (console.log)
            console.log(message);
    };
    AmpIvTrimPlugin.prototype.pauseAtEnd = function () {
        if (this.player.paused())
            return;
        var currentTrim = this.getCurrentTrimEffect();
        if (this.player.currentTime() >= currentTrim.Stop) {
            this.player.pause();
            this.player.currentTime(currentTrim.Stop);
        }
    };
    AmpIvTrimPlugin.prototype.dragStart = function (dragHandle) {
        if (!this.player.paused())
            this.player.pause();
        this.currentDrag = dragHandle;
    };
    AmpIvTrimPlugin.prototype.dragStop = function () {
        this.currentDrag = DragTrimHandleType.None;
    };
    AmpIvTrimPlugin.prototype.getCurrentTrimEffect = function () {
        var pw = this.$progressControl.width();
        var left = this.$trimArea.position().left * 1.0 / pw;
        var right = (this.$trimArea.position().left + 4 + this.$trimArea.width()) * 1.0 / pw;
        var duration = this.player.duration();
        var start = Math.round(left * duration * 10) / 10;
        var stop = Math.round(right * duration * 10) / 10;
        return new effects_1.TrimEffect(start, stop);
    };
    AmpIvTrimPlugin.pluginId = 'iVtrimPlugin';
    return AmpIvTrimPlugin;
}());
var DragTrimHandleType;
(function (DragTrimHandleType) {
    DragTrimHandleType[DragTrimHandleType["None"] = 0] = "None";
    DragTrimHandleType[DragTrimHandleType["Left"] = 1] = "Left";
    DragTrimHandleType[DragTrimHandleType["Right"] = 2] = "Right";
})(DragTrimHandleType || (DragTrimHandleType = {}));
amp.plugin(AmpIvTrimPlugin.pluginId, function (options) {
    AmpIvTrimPlugin.current = new AmpIvTrimPlugin(this, options);
});


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/AzureMediaPlayer.ts":
/*!*******************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/AzureMediaPlayer.ts ***!
  \*******************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AzureMediaPlayer = void 0;
var NumberUtil_1 = __webpack_require__(/*! ../lib/NumberUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/NumberUtil.ts");
var Util_1 = __webpack_require__(/*! ../lib/Util */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts");
var UriUtil_1 = __webpack_require__(/*! ../lib/UriUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts");
var LanguageUtil_1 = __webpack_require__(/*! ../lib/LanguageUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/LanguageUtil.ts");
__webpack_require__(/*! ../lib/Polyfills */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Polyfills.ts");
var ErrorUtil_1 = __webpack_require__(/*! ../lib/ErrorUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/ErrorUtil.ts");
var ElementResizer_1 = __webpack_require__(/*! ./ElementResizer */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/ElementResizer.ts");
var EmbedResizeMode_1 = __webpack_require__(/*! ./EmbedResizeMode */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/EmbedResizeMode.ts");
var MessageLevel_1 = __webpack_require__(/*! ./MessageLevel */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/MessageLevel.ts");
var AzureMediaPlayer = exports.AzureMediaPlayer = (function () {
    function AzureMediaPlayer(id, options) {
        this.debugProgressNo = 0;
        this.disposed = false;
        this.preInitBackground = null;
        this.initPausedChecked = false;
        this.handlers = {};
        var videoElement = document.getElementById(id);
        if (!videoElement)
            throw "No element with id ".concat(id, " was found");
        if (videoElement.tagName.toLocaleLowerCase() !== "video")
            throw "Element with id ".concat(id, " is no video tag. (").concat(videoElement.tagName, ")");
        var baseOptions = this.getSetupOptionsFromVideoTag(videoElement) || { debug: false };
        var overrideOptions = options || {};
        this.options = Object.assign(baseOptions, overrideOptions);
        var source = this.options.manifestUrl || AzureMediaPlayer.getManifestUrlFromVideoTag(videoElement);
        if (!source)
            throw "Missing attribute ".concat(AzureMediaPlayer.manifestUrlAttributeName, " on video element ").concat(id);
        source = UriUtil_1.UriUtil.changeExtension(source, ".json");
        this.queryStringParams = UriUtil_1.UriUtil.getQueryStringParameters(source);
        this.id = id;
        this.source = source;
        this.videoElement = videoElement;
        this.beginPlayerInit();
        if (this.options.disableLoaderIcon) {
            this.videoElement.className += " disable-loader-icon";
        }
        this.userSettings = this.loadUserSettings();
        AzureMediaPlayer.players[id] = this;
    }
    AzureMediaPlayer.setupAsync = function (id, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var player, e_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    player = new AzureMediaPlayer(id, options);
                                    player.log("Player created");
                                    return [4, player.initAsync()];
                                case 1:
                                    _a.sent();
                                    player.log("Init completed");
                                    resolve(player);
                                    return [3, 3];
                                case 2:
                                    e_1 = _a.sent();
                                    (player || console).log("Init failed " + e_1);
                                    reject(e_1);
                                    return [3, 3];
                                case 3: return [2];
                            }
                        });
                    }); })];
            });
        });
    };
    AzureMediaPlayer.getManifestUrlFromVideoTag = function (video) {
        if (!video)
            return null;
        var dataAtt = video.attributes[AzureMediaPlayer.manifestUrlAttributeName];
        if (!dataAtt)
            return null;
        var manifestUrl = dataAtt.value;
        video.removeAttribute(AzureMediaPlayer.manifestUrlAttributeName);
        return manifestUrl;
    };
    AzureMediaPlayer.prototype.getSetupOptionsFromVideoTag = function (video) {
        if (!video)
            return null;
        var dataAtt = video.attributes[AzureMediaPlayer.setupOptionsAttributeName];
        if (!dataAtt)
            return null;
        var optionsString = dataAtt.value;
        try {
            var options = JSON.parse(optionsString);
            video.removeAttribute(AzureMediaPlayer.setupOptionsAttributeName);
            return options;
        }
        catch (e) {
            this.log("Failed to parse options from video attribute " + AzureMediaPlayer.setupOptionsAttributeName + "\n" + e);
        }
        return null;
    };
    AzureMediaPlayer.prototype.beginPlayerInit = function () {
        if (!this.options.displayDuringInit) {
            this.videoElement.className += " " + AzureMediaPlayer.loadingClassName;
            if (this.options.initBackground) {
                this.preInitBackground = this.videoElement.parentElement.style.background;
                this.videoElement.parentElement.style.background = this.options.initBackground;
            }
        }
    };
    AzureMediaPlayer.prototype.endPlayerInit = function () {
        this.log("End player init");
        try {
            var playerDom = document.getElementById(this.id);
            if (!playerDom) {
                this.warn("No player component was found " + this.id + ". It might have been removed. Player init interrupted");
            }
            else {
                if (this.options.embedResizeMode === EmbedResizeMode_1.EmbedResizeMode.ScaleToFill || this.options.embedResizeMode === EmbedResizeMode_1.EmbedResizeMode.ScaleToFit) {
                    var ar = this.player.videoWidth() / this.player.videoHeight();
                    this.playerResizer = new ElementResizer_1.ElementResizer(playerDom, this.options.embedResizeMode, ar, this);
                }
            }
            var startAt = NumberUtil_1.NumberUtil.parseFloat(this.options.startAt);
            if (startAt > 0 && startAt < this.player.duration()) {
                this.player.currentAbsoluteTime(startAt);
            }
            if (playerDom && !this.options.displayDuringInit) {
                playerDom.className = playerDom.className.replace(" " + AzureMediaPlayer.loadingClassName, "");
                if (this.options.initBackground) {
                    playerDom.parentElement.style.background = this.preInitBackground;
                }
            }
        }
        catch (e) {
            this.error("endPlayerInit failed: " + e);
        }
    };
    AzureMediaPlayer.prototype.loadUserSettings = function () {
        try {
            var json = window.localStorage.getItem(AzureMediaPlayer.userSettingsStorageKey);
            if (json) {
                return JSON.parse(json);
            }
        }
        catch (e) {
            this.log("Failed to read user settings from local storage, falling back to local. ".concat(ErrorUtil_1.ErrorUtil.toString(e)));
        }
        return AzureMediaPlayer.defaultUserSettings;
    };
    AzureMediaPlayer.prototype.saveUserSettings = function () {
        try {
            window.localStorage.setItem(AzureMediaPlayer.userSettingsStorageKey, JSON.stringify(this.userSettings));
        }
        catch (e) {
            this.log("Failed to save user settings ".concat(ErrorUtil_1.ErrorUtil.toString(e)));
        }
    };
    AzureMediaPlayer.prototype.addEventListener = function (message, handler) {
        var self = this;
        var wrap = function () { handler(self.player); };
        if (this.player) {
            this.player.addEventListener(message, wrap);
        }
        else {
            this.handlers[message] = wrap;
        }
    };
    AzureMediaPlayer.prototype.findActiveTextTrack = function (language, tracks) {
        this.log("Find active text track " + language);
        try {
            if (!tracks || !tracks.length || !language) {
                this.log("No track or language defined");
                return null;
            }
            var languages = language.split(/\s*,\s*/);
            for (var i = 0; i < languages.length; i++) {
                this.log("Checking track " + i);
                var lang = languages[i].toLowerCase();
                for (var j = 0; j < tracks.length; j++) {
                    var track = tracks[j];
                    if (track.kind !== "subtitles" && track.kind !== "captions")
                        continue;
                    if (track.srclang && track.srclang.toLowerCase() === lang) {
                        this.log("matched track");
                        return track;
                    }
                }
            }
        }
        catch (e) {
            this.log("Error finding active text track " + e);
        }
        this.log("No track matached");
        return null;
    };
    AzureMediaPlayer.prototype.getMatchingTextTrackByUrl = function (url, tracks) {
        if (!url || !tracks || !tracks.length)
            return null;
        for (var i = 0; i < tracks.length; i++) {
            if (url == tracks[i].src)
                return tracks[i];
        }
        return null;
    };
    AzureMediaPlayer.prototype.getMatchingPlayerTrackByUrl = function (url, tracks) {
        if (!url || !tracks || !tracks.length)
            return null;
        for (var i = 0; i < tracks.length; i++) {
            if (url == tracks[i].src)
                return tracks[i];
        }
        return null;
    };
    AzureMediaPlayer.prototype.handleResize = function () {
        if (this.playerResizer) {
            this.playerResizer.resize();
        }
    };
    AzureMediaPlayer.prototype.initAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var self_1, ampOptions, lang, response, sourceElement, textTracks, textDictionary_1, activeTextTrack, i, suggestedActiveTextTrackLanguage, events, e_2;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    this.log("initAsync");
                                    self_1 = this;
                                    ampOptions = {
                                        logo: { enabled: false },
                                        plugins: this.options.plugins,
                                        skinConfig: {}
                                    };
                                    ampOptions["nativeControlsForTouch"] = false;
                                    lang = AzureMediaPlayer.lu.currentLanguage();
                                    ampOptions["language"] = lang;
                                    self_1.log("setting language to '" + lang + "'");
                                    if (this.options.autoplay !== undefined) {
                                        ampOptions.autoplay = this.options.autoplay;
                                    }
                                    if (this.options.muted !== undefined) {
                                        ampOptions.muted = this.options.muted;
                                    }
                                    if (this.options.controls !== undefined) {
                                        ampOptions.controls = this.options.controls;
                                    }
                                    if (this.options.disableFullscreen) {
                                        ampOptions.hotKeys = { enableFullscreen: false };
                                    }
                                    self_1.log("".concat(AzureMediaPlayer.lu.translate("Resolving url"), " ").concat(this.source));
                                    return [4, this.resolveUrlAsync(this.source)];
                                case 1:
                                    response = _a.sent();
                                    this.hideInfoScreen();
                                    self_1.log("Setting up player for url ".concat(response.manifestUrl));
                                    self_1.player = amp(this.id, ampOptions);
                                    sourceElement = [
                                        { src: response.manifestUrl, type: "application/vnd.ms-sstr+xml" }
                                    ];
                                    textTracks = response.tracks;
                                    if (!textTracks)
                                        textTracks = [];
                                    textDictionary_1 = {};
                                    self_1.log("#Text tracks " + textTracks.length);
                                    textTracks.forEach(function (t) { textDictionary_1[t.src] = t.srclang; });
                                    activeTextTrack = void 0;
                                    if (this.options.disableTextTracks) {
                                        textTracks = null;
                                    }
                                    else {
                                        if (textTracks && textTracks.length) {
                                            for (i = 0; i < textTracks.length; i++) {
                                                if (textTracks[i].kind === "subtitles")
                                                    textTracks[i].kind = "captions";
                                                textTracks[i].src = UriUtil_1.UriUtil.addQueryStringParameters(textTracks[i].src, this.queryStringParams);
                                                self_1.log("Track " + i + ": " + textTracks[i].label + "," + textTracks[i].kind + "," + textTracks[i].src);
                                            }
                                            self_1.log("SuggestedActiveTextTrackLanguage");
                                            suggestedActiveTextTrackLanguage = this.options.activeTextTrackLanguage || this.userSettings.textLanguage;
                                            self_1.log("Finding track matching suggested active text track language: " + suggestedActiveTextTrackLanguage);
                                            activeTextTrack = this.findActiveTextTrack(suggestedActiveTextTrackLanguage, textTracks);
                                            self_1.log("User text language " + this.userSettings.textLanguage);
                                            if (!activeTextTrack && this.userSettings.textLanguage) {
                                                activeTextTrack = textTracks[0];
                                            }
                                            if (activeTextTrack) {
                                                self_1.log("Active text track: " + activeTextTrack.label + "," + activeTextTrack.kind + "," + activeTextTrack.src);
                                            }
                                        }
                                    }
                                    self_1.player.src(sourceElement, textTracks);
                                    if (activeTextTrack) {
                                        this.activePlayerTextTrack = this.getMatchingPlayerTrackByUrl(activeTextTrack.src, self_1.player.textTracks());
                                        if (this.activePlayerTextTrack) {
                                            self_1.log("ActivePlayerTextTrack: " + this.activePlayerTextTrack.src);
                                        }
                                        else {
                                            self_1.log("ActivePlayerTextTrack: none");
                                        }
                                    }
                                    events = Object.keys(self_1.handlers);
                                    events.forEach(function (e) {
                                        self_1.log("Adding event listener for " + e);
                                        self_1.player.addEventListener(e, self_1.handlers[e]);
                                    });
                                    self_1.handlers = {};
                                    self_1.log("Adding handler for player.ready");
                                    self_1.player.ready(function () {
                                        try {
                                            self_1.log("Player ready. Starting playback");
                                            if (self_1.options.disableFullscreen) {
                                                var fullscreenButton = document.getElementsByClassName("vjs-fullscreen-control")[0];
                                                if (fullscreenButton) {
                                                    fullscreenButton.style.display = "none";
                                                }
                                            }
                                            var playButton = document.getElementsByClassName("vjs-big-play-button")[0];
                                            if (playButton) {
                                                playButton.style.top = "50%";
                                                playButton.style.left = "50%";
                                                playButton.style.transform = "translate(-50%, -50%)";
                                            }
                                            try {
                                                if (self_1.activePlayerTextTrack) {
                                                    self_1.player.setActiveTextTrack(self_1.activePlayerTextTrack);
                                                }
                                            }
                                            catch (e) {
                                                self_1.log("Failed to set active text track language" + e);
                                            }
                                            self_1.log("Adding handler for player." + amp.eventName.play);
                                            self_1.player.addEventListener(amp.eventName.play, function () {
                                                self_1.log("play");
                                            });
                                            self_1.log("Adding handler for player." + amp.eventName.start);
                                            self_1.player.addEventListener(amp.eventName.start, function () {
                                                self_1.log("start");
                                                if (!self_1.activePlayerTrackChangedInterval) {
                                                    var waitForTrackToBeLoaded = 0;
                                                    var interval = 2000;
                                                    if (self_1.activePlayerTextTrack)
                                                        waitForTrackToBeLoaded = 1;
                                                    self_1.activePlayerTrackChangedInterval = window.setInterval(function () {
                                                        if (waitForTrackToBeLoaded > 0) {
                                                            self_1.log("waiting for active track to be loaded");
                                                            waitForTrackToBeLoaded--;
                                                            return;
                                                        }
                                                        try {
                                                            var currentTextTrack = self_1.player.getCurrentTextTrack();
                                                            if (!currentTextTrack) {
                                                                if (!self_1.activePlayerTextTrack)
                                                                    return;
                                                                if (!self_1.userSettings.textLanguage)
                                                                    return;
                                                                self_1.log("User turned of text language");
                                                                self_1.activePlayerTextTrack = null;
                                                                self_1.userSettings.textLanguage = null;
                                                                self_1.saveUserSettings();
                                                                return;
                                                            }
                                                            if (self_1.activePlayerTextTrack && self_1.activePlayerTextTrack.src == currentTextTrack.src)
                                                                return;
                                                            self_1.activePlayerTextTrack = currentTextTrack;
                                                            self_1.log("User changed text track url to ".concat(currentTextTrack.src));
                                                            var srclang = textDictionary_1[currentTextTrack.src];
                                                            if (!srclang) {
                                                                self_1.log("Cannot find matching text track for url ".concat(currentTextTrack.src));
                                                                return;
                                                            }
                                                            if (srclang == self_1.userSettings.textLanguage)
                                                                return;
                                                            self_1.log("User changed text language to ".concat(srclang));
                                                            self_1.userSettings.textLanguage = srclang;
                                                            self_1.saveUserSettings();
                                                            return;
                                                        }
                                                        catch (e) {
                                                            self_1.log("Failed to track track changes ".concat(ErrorUtil_1.ErrorUtil.toString(e)));
                                                            window.clearInterval(self_1.activePlayerTrackChangedInterval);
                                                        }
                                                    }, interval);
                                                }
                                            });
                                            self_1.log("Adding handler for player." + amp.eventName.playing);
                                            self_1.player.addEventListener(amp.eventName.playing, function () {
                                                self_1.log("playing");
                                                if (!self_1.initPausedChecked) {
                                                    self_1.initPausedChecked = true;
                                                    if (self_1.options.initPaused) {
                                                        self_1.log("Pausing initPaused");
                                                        self_1.player.pause();
                                                        var startAt = NumberUtil_1.NumberUtil.parseFloat(self_1.options.startAt) || 0;
                                                        if (startAt < 0) {
                                                            startAt = 0;
                                                        }
                                                        if (startAt > self_1.player.duration()) {
                                                            startAt = self_1.player.duration();
                                                        }
                                                        self_1.log("SetStart to " + startAt);
                                                        self_1.player.currentAbsoluteTime(startAt);
                                                    }
                                                }
                                            });
                                            self_1.log("Adding handler for player." + amp.eventName.resume);
                                            self_1.player.addEventListener(amp.eventName.resume, function () {
                                                self_1.log("resume");
                                            });
                                            self_1.log("Adding handler for player." + amp.eventName.loadeddata);
                                            self_1.player.addEventListener(amp.eventName.loadeddata, function (amp) {
                                                self_1.log("loaded data");
                                            });
                                            if (self_1.options.loop) {
                                                self_1.log("Adding handler for player." + amp.eventName.ended);
                                                self_1.player.addEventListener(amp.eventName.ended, function (amp) {
                                                    var startAt = NumberUtil_1.NumberUtil.parseFloat(self_1.options.startAt) || 0;
                                                    self_1.log("ended, looping from " + startAt);
                                                    self_1.player.currentAbsoluteTime(startAt);
                                                    self_1.player.play();
                                                });
                                            }
                                            var settingsView = document.getElementsByClassName("vjs-caption-settings")[0];
                                            if (self_1.player.width() < 480 || self_1.player.height() < 340) {
                                                var scale = Math.min(self_1.player.width() / 480.0, self_1.player.height() / 340.0);
                                                settingsView.style.top = "50%";
                                                settingsView.style.height = "20em";
                                                var strTransform = "translate(-50%, -55%) scale(".concat(scale.toString(), ")");
                                                settingsView.style.webkitTransform = strTransform;
                                                settingsView.style.transform = strTransform;
                                            }
                                            self_1.endPlayerInit();
                                            self_1.log("Player ready, done");
                                            resolve();
                                        }
                                        catch (e) {
                                            self_1.error("Player ready failed. " + e);
                                            reject(e);
                                        }
                                    });
                                    return [3, 3];
                                case 2:
                                    e_2 = _a.sent();
                                    reject(e_2);
                                    return [3, 3];
                                case 3: return [2];
                            }
                        });
                    }); })];
            });
        });
    };
    AzureMediaPlayer.prototype.dispose = function () {
        this.log("Disposing");
        this.disposed = true;
        if (this.playerResizer) {
            this.playerResizer.dispose();
            this.playerResizer = null;
        }
        window.clearInterval(this.activePlayerTrackChangedInterval);
        if (this.player)
            this.player.dispose();
    };
    AzureMediaPlayer.prototype.log = function (msg, force) {
        if (force === void 0) { force = false; }
        if ((force || !this.options || this.options.debug) && console && console.log)
            console.log(msg);
    };
    AzureMediaPlayer.prototype.warn = function (msg) {
        this.log("WARN: " + msg, true);
    };
    AzureMediaPlayer.prototype.error = function (msg) {
        this.log("ERROR: " + msg, true);
    };
    AzureMediaPlayer.prototype.resolveUrlAsync = function (url) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var r, shouldRetryAutomatically, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 9, , 10]);
                        _a.label = 1;
                    case 1:
                        if (this.disposed)
                            throw "Player disposed";
                        if (!this.options.debugProgress) return [3, 3];
                        this.showInfoScreen(Object.assign({ message: AzureMediaPlayer.lu.translate("Conversion in progress..."), progress: this.debugProgressNo }, r), MessageLevel_1.MessageLevel.Info);
                        this.debugProgressNo++;
                        if (this.debugProgressNo > 100)
                            this.debugProgressNo = 0;
                        return [4, AzureMediaPlayer.delay(200)];
                    case 2:
                        _a.sent();
                        return [3, 7];
                    case 3: return [4, this.getIvMdAsync(url)];
                    case 4:
                        r = _a.sent();
                        if (r.response) {
                            resolve(r.response);
                            return [2];
                        }
                        if (!(r.status === 503)) return [3, 6];
                        shouldRetryAutomatically = r.retryAfter > 0;
                        if (!shouldRetryAutomatically) {
                            throw r.message;
                        }
                        this.showInfoScreen(Object.assign({ message: AzureMediaPlayer.lu.translate("Conversion in progress..."), progress: 0 }, r), MessageLevel_1.MessageLevel.Info);
                        return [4, AzureMediaPlayer.delay((r.retryAfter || 5) * 1000)];
                    case 5:
                        _a.sent();
                        return [3, 7];
                    case 6:
                        if (r.status === 404) {
                            throw "".concat(AzureMediaPlayer.lu.translate("Media was not found on server"), ": ").concat(r.status);
                        }
                        else {
                            throw "".concat(AzureMediaPlayer.lu.translate("Failed to get resource"), " ").concat(url, ". ").concat(AzureMediaPlayer.lu.translate("Response code"), " ").concat(r.status);
                        }
                        _a.label = 7;
                    case 7:
                        if (true) return [3, 1];
                        _a.label = 8;
                    case 8: return [3, 10];
                    case 9:
                        e_3 = _a.sent();
                        this.showInfoScreen(Object.assign(r || { status: -1 }, { message: e_3, progress: -1 }), MessageLevel_1.MessageLevel.Error);
                        this.log(e_3);
                        reject(e_3);
                        return [3, 10];
                    case 10: return [2];
                }
            });
        }); });
    };
    AzureMediaPlayer.delay = function (ms) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve) { return setTimeout(resolve, ms); })];
            });
        });
    };
    AzureMediaPlayer.prototype.hideInfoScreen = function () {
        this.videoElement.style.display = "";
        if (this.infoElement) {
            this.infoElement.parentNode.removeChild(this.infoElement);
            this.infoElement = null;
        }
    };
    AzureMediaPlayer.prototype.showInfoScreen = function (response, level) {
        var message = response.message;
        var progressPercent = response.progress || -1;
        var moreInformation = response.moreInformation;
        this.log(message + ":" + progressPercent + "%");
        if (!this.infoElement) {
            var parent_1 = this.videoElement.parentNode;
            if (!parent_1.insertBefore) {
                return;
            }
            var info = this.infoElement = document.createElement("div");
            info.className = "ivAmp-info";
            if (this.options.embedResizeMode === EmbedResizeMode_1.EmbedResizeMode.Default) {
                info.style.width = "".concat(this.videoElement.clientWidth, "px");
                info.style.height = "".concat(this.videoElement.clientHeight, "px");
            }
            else {
                info.style.width = "100%";
                info.style.height = "100%";
            }
            var m = this.messageElement = document.createElement("div");
            m.className = "message";
            info.appendChild(m);
            var pp = this.progressBarBaseElement = document.createElement("div");
            pp.className = "progress-bar";
            info.appendChild(pp);
            var p = this.progressBarElement = document.createElement("div");
            pp.appendChild(p);
            parent_1.insertBefore(info, this.videoElement.nextSibling);
        }
        var messageClass = "message message-" + MessageLevel_1.MessageLevel[level].toString().toLowerCase();
        this.messageElement.className = messageClass;
        this.videoElement.style.display = "none";
        message = Util_1.Util.htmlEncode(message);
        message = message.replace(/[\012\015]+/g, "<br/>");
        if (moreInformation) {
            message += "<br/><a href='".concat(moreInformation, "' target='_contact_meriworks'>").concat(AzureMediaPlayer.lu.translate("Contact us for more information"), "</a>");
        }
        this.messageElement.innerHTML = message;
        if (progressPercent < 0) {
            this.progressBarBaseElement.style.display = "none";
        }
        else {
            if (progressPercent > 100)
                progressPercent = 100;
            this.progressBarBaseElement.style.display = "";
            this.progressBarElement.style.width = "".concat(progressPercent, "%");
        }
    };
    AzureMediaPlayer.prototype.getIvMdAsync = function (url) {
        var _this = this;
        return new Promise(function (resolve) {
            var xhr = new XMLHttpRequest();
            xhr.withCredentials = true;
            var resolved = false;
            xhr.onreadystatechange = function () {
                _this.log("onreadystatechange ".concat(xhr.readyState, ":").concat(xhr.status, ":").concat(resolved));
                if (resolved)
                    return;
                if (xhr.readyState !== 4)
                    return;
                var response = { status: xhr.status };
                switch (response.status) {
                    case 200:
                        var data = JSON.parse(xhr.responseText);
                        if (data && data.manifestUrl) {
                            response.response = data;
                        }
                        else {
                            response.message = "".concat(AzureMediaPlayer.lu.translate("Failed to retrieve manifest url"), ". ").concat(xhr.responseText);
                        }
                        break;
                    case 503:
                        response.retryAfter = NumberUtil_1.NumberUtil.parseInt(xhr.getResponseHeader("Retry-After"), null);
                        response.progress = NumberUtil_1.NumberUtil.parseInt(xhr.getResponseHeader("X-Progress-Percent"));
                        response.exceptionType = xhr.getResponseHeader("X-Exception-Type");
                        response.message = xhr.getResponseHeader("X-Exception-Message");
                        response.moreInformation = xhr.getResponseHeader("X-More-Information");
                        if (response.message)
                            response.message = response.message.replace(/%0a/ig, "\n");
                        response.message = decodeURIComponent(escape(response.message));
                        break;
                    default:
                        response.message = xhr.responseText;
                        break;
                }
                resolved = true;
                resolve(response);
                return;
            };
            xhr.open('GET', url, true);
            xhr.send();
        });
    };
    AzureMediaPlayer.initAllVideo = function (options) {
        options = options || {};
        var videos = document.getElementsByTagName("video");
        if (!videos || !videos.length)
            return;
        for (var i = 0; i < videos.length; i++) {
            var video = videos[i];
            var id = video.id;
            if (!id)
                continue;
            var manifestUrl = this.getManifestUrlFromVideoTag(video);
            if (!manifestUrl)
                continue;
            options.manifestUrl = manifestUrl;
            var player = new AzureMediaPlayer(id, options);
            player.initAsync();
        }
    };
    AzureMediaPlayer.initDocument = function () {
        var init = function () {
            AzureMediaPlayer.initAllVideo();
        };
        if (window.addEventListener) {
            window.addEventListener("load", init);
        }
        else {
            window.onload = function () { return init; };
        }
    };
    AzureMediaPlayer.defaultUserSettings = {};
    AzureMediaPlayer.players = {};
    AzureMediaPlayer.loadingClassName = "init-loading";
    AzureMediaPlayer.manifestUrlAttributeName = "data-ivmdurl";
    AzureMediaPlayer.setupOptionsAttributeName = "data-ivsetup";
    AzureMediaPlayer.lu = LanguageUtil_1.LanguageUtil.registerTranslations("AzureMediaPlayer", ["sv", "no", "de"], {
        "Failed to retrieve manifest url": [
            "Misslyckades att hämta manifestfilen",
            "Kunne ikke hente manifest url",
            "Manifest-URL konnte nicht abgerufen werden"
        ],
        "Resolving url": [
            "Hämtar url",
            "Løse url",
            "URL auflösen"
        ],
        "Conversion in progress...": [
            "Konvertering pågår...",
            "Konvertering pågår...",
            "Umstellung läuft..."
        ],
        "Media was not found on server": [
            "Videon hittades inte på servern",
            "Media ble ikke funnet på serveren",
            "Medien wurden auf dem Server nicht gefunden"
        ],
        "Failed to get resource": [
            "Kunde inte hämta resurs",
            "Kunne ikke skaffe ressurs",
            "Ressource konnte nicht abgerufen werden"
        ],
        "Response code": [
            "Svarskod",
            "Responskode",
            "Antwortcode"
        ],
        "Contact us for more information": [
            "Kontakta oss för mer information",
            "Kontakt oss for mer informasjon",
            "Kontaktieren Sie uns für weitere Informationen"
        ]
    });
    AzureMediaPlayer.userSettingsStorageKey = "IV-AzureMediaPlayer-UserSettings";
    return AzureMediaPlayer;
}());
(window.ImageVault = window.ImageVault || {}).AzureMediaPlayer = AzureMediaPlayer;
window.ImageVault.AzureMediaPlayer.initDocument();


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/ElementResizer.ts":
/*!*****************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/ElementResizer.ts ***!
  \*****************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ElementResizer = void 0;
var EmbedResizeMode_1 = __webpack_require__(/*! ./EmbedResizeMode */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/EmbedResizeMode.ts");
var ElementResizer = (function () {
    function ElementResizer(element, resizeMode, aspectRatio, logger) {
        if (aspectRatio === void 0) { aspectRatio = 0; }
        if (logger === void 0) { logger = null; }
        var self = this;
        this.element = element;
        this.parent = element.parentElement;
        this.aspectRatio = aspectRatio || element.clientWidth / element.clientHeight;
        this.resizeMode = resizeMode;
        this.logger = logger || { log: function () { } };
        this.resize();
        window.addEventListener("resize", function () { self.resize(); });
        return this;
    }
    ElementResizer.prototype.dispose = function () {
        window.removeEventListener("resize", this.resize);
    };
    ElementResizer.prototype.resize = function () {
        if (this.resizeMode !== EmbedResizeMode_1.EmbedResizeMode.ScaleToFill && this.resizeMode !== EmbedResizeMode_1.EmbedResizeMode.ScaleToFit)
            return;
        var w = this.parent.clientWidth;
        var h = this.parent.clientHeight;
        if (this.parent.tagName.toLowerCase() === "body") {
            w = window.innerWidth;
            h = window.innerHeight;
        }
        var pa = w / h;
        var cw = w;
        var ch = h;
        var mt = 0;
        var ml = 0;
        var targetMoreLandscape = pa > this.aspectRatio;
        var keepHeight = this.resizeMode === EmbedResizeMode_1.EmbedResizeMode.ScaleToFit && targetMoreLandscape
            || this.resizeMode === EmbedResizeMode_1.EmbedResizeMode.ScaleToFill && !targetMoreLandscape;
        if (keepHeight) {
            cw = this.aspectRatio * ch;
            ml = (w - cw) / 2;
            this.element.style.marginTop = "0";
            this.element.style.marginLeft = ml + "px";
        }
        else {
            ch = cw / this.aspectRatio;
            mt = (h - ch) / 2;
            this.element.style.marginTop = mt + "px";
            this.element.style.marginLeft = "0";
        }
        this.element.style.width = cw + "px";
        this.element.style.height = ch + "px";
        this.logger.log("" + EmbedResizeMode_1.EmbedResizeMode[this.resizeMode].toString() + " (" + cw + "," + ch + ") (" + ml + "," + mt + ") inside (" + w + "," + h + ")");
    };
    return ElementResizer;
}());
exports.ElementResizer = ElementResizer;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/EmbedResizeMode.ts":
/*!******************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/EmbedResizeMode.ts ***!
  \******************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.EmbedResizeMode = void 0;
var EmbedResizeMode;
(function (EmbedResizeMode) {
    EmbedResizeMode[EmbedResizeMode["Default"] = 0] = "Default";
    EmbedResizeMode[EmbedResizeMode["ScaleToFit"] = 1] = "ScaleToFit";
    EmbedResizeMode[EmbedResizeMode["ScaleToFill"] = 2] = "ScaleToFill";
})(EmbedResizeMode || (exports.EmbedResizeMode = EmbedResizeMode = {}));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/MessageLevel.ts":
/*!***************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ivAmp/MessageLevel.ts ***!
  \***************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MessageLevel = void 0;
var MessageLevel;
(function (MessageLevel) {
    MessageLevel[MessageLevel["Info"] = 0] = "Info";
    MessageLevel[MessageLevel["Success"] = 1] = "Success";
    MessageLevel[MessageLevel["Warning"] = 2] = "Warning";
    MessageLevel[MessageLevel["Error"] = 3] = "Error";
})(MessageLevel || (exports.MessageLevel = MessageLevel = {}));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/ErrorUtil.ts":
/*!**********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/ErrorUtil.ts ***!
  \**********************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ErrorUtil = void 0;
var ErrorUtil = (function () {
    function ErrorUtil() {
    }
    ErrorUtil.isError = function (error) {
        return error.message !== undefined;
    };
    ErrorUtil.toString = function (error) {
        var msg = "Unknown";
        if (typeof error === 'string')
            return error;
        if (this.isError(error))
            return error.message;
        if (error) {
            if (error.exception) {
                msg = error.exception.message;
            }
            else {
                msg = error.statusCode + " - " + error.statusText;
            }
        }
        return msg;
    };
    return ErrorUtil;
}());
exports.ErrorUtil = ErrorUtil;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/LanguageUtil.ts":
/*!*************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/LanguageUtil.ts ***!
  \*************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.LanguageUtil = void 0;
var LanguageUtil = exports.LanguageUtil = (function () {
    function LanguageUtil(baseKey, fallbackLanguage) {
        if (fallbackLanguage === void 0) { fallbackLanguage = "en"; }
        this._baseKey = baseKey;
        this._fallbackLanguage = fallbackLanguage;
    }
    LanguageUtil.prototype.currentLanguage = function () {
        return document.documentElement.lang || navigator.language || this._fallbackLanguage;
    };
    LanguageUtil.prototype.currentTranslations = function () {
        return LanguageUtil._languages[this.currentLanguage()] || {};
    };
    LanguageUtil.prototype.translate = function (key, fallback) {
        var k = this._baseKey + key;
        var t = this.currentTranslations();
        return t[k] || fallback || key;
    };
    LanguageUtil.registerTranslations = function (baseKey, languages, translations) {
        if (!translations)
            return;
        languages.map(function (lang, langIndex) {
            var langData = LanguageUtil._languages[lang];
            if (!langData) {
                langData = {};
                LanguageUtil._languages[lang] = langData;
            }
            Object.keys(translations).map(function (key) {
                var tray = translations[key];
                if (!tray || !tray.length || tray.length <= langIndex)
                    return;
                var value = translations[key][langIndex];
                var k = baseKey + key;
                langData[k] = value;
            });
        });
        return new LanguageUtil(baseKey);
    };
    LanguageUtil._languages = {};
    return LanguageUtil;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/NumberUtil.ts":
/*!***********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/NumberUtil.ts ***!
  \***********************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.NumberUtil = void 0;
var NumberUtil = (function () {
    function NumberUtil() {
    }
    NumberUtil.parseInt = function (text, defaultValue) {
        var i = parseInt(text);
        if (isNaN(i))
            return defaultValue || 0;
        return i;
    };
    NumberUtil.parseFloat = function (text, defaultValue) {
        var f = parseFloat(text);
        if (isNaN(f))
            return defaultValue || 0;
        return f;
    };
    return NumberUtil;
}());
exports.NumberUtil = NumberUtil;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Polyfills.ts":
/*!**********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Polyfills.ts ***!
  \**********************************************************************************************/
/***/ (() => {

if (typeof Object.assign !== 'function') {
    Object.defineProperty(Object, "assign", {
        value: function assign(target, varArgs) {
            'use strict';
            if (target === null || target === undefined) {
                throw new TypeError('Cannot convert undefined or null to object');
            }
            var to = Object(target);
            for (var index = 1; index < arguments.length; index++) {
                var nextSource = arguments[index];
                if (nextSource !== null && nextSource !== undefined) {
                    for (var nextKey in nextSource) {
                        if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
                            to[nextKey] = nextSource[nextKey];
                        }
                    }
                }
            }
            return to;
        },
        writable: true,
        configurable: true
    });
}


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts":
/*!********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts ***!
  \********************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.UriUtil = void 0;
var UriUtil = (function () {
    function UriUtil() {
    }
    UriUtil.toQueryString = function (q) {
        if (!q)
            return "";
        var queryString = Object.keys(q).map(function (key) {
            return encodeURIComponent(key) + '=' + encodeURIComponent(q[key]);
        }).join('&');
        return queryString;
    };
    UriUtil.changeExtension = function (url, extension) {
        var rex = /^((?:(?:\w+:)?\/\/[^\/]+\/)?[^?]*?)(\.[^\.\?]*)?($|\?.*$)/i;
        if (!url)
            return url;
        var m = url.match(rex);
        if (!m)
            return url;
        extension = extension || "";
        if (extension && extension.length && extension[0] !== '.')
            extension = "." + extension;
        var newUrl = m[1] + extension + m[3];
        return newUrl;
    };
    UriUtil.getQueryStringParameters = function (url) {
        var p = {};
        if (!url)
            return p;
        var rex = /\?(.*)(\#.*)?$/i;
        var m = url.match(rex);
        if (!m)
            return p;
        var qs = m[1];
        if (!qs)
            return p;
        var kv = qs.split("&");
        for (var i = 0; i < kv.length; i++) {
            var pair = kv[i].split("=");
            var key = decodeURIComponent(pair[0]);
            var value = decodeURIComponent(pair.length > 1 ? pair[1] : "");
            p[key] = value;
        }
        return p;
    };
    UriUtil.stripQuery = function (url) {
        if (!url)
            return url;
        var i = url.indexOf("?");
        if (i >= 0)
            return url.substring(0, i);
        return url;
    };
    UriUtil.addQueryStringParameters = function (url, queryStringParams) {
        if (!url)
            return url;
        if (!queryStringParams || !Object.keys(queryStringParams).length)
            return url;
        var q = UriUtil.getQueryStringParameters(url);
        var baseUrl = UriUtil.stripQuery(url);
        if (!q || !Object.keys(q).length) {
            q = queryStringParams;
        }
        else {
            q = Object.assign(queryStringParams, q);
        }
        return baseUrl + "?" + UriUtil.toQueryString(q);
    };
    return UriUtil;
}());
exports.UriUtil = UriUtil;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts":
/*!*****************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts ***!
  \*****************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Util = void 0;
var Util = (function () {
    function Util() {
    }
    Util.has = function (object, key) {
        return object ? object.hasOwnProperty(key) : false;
    };
    Util.get = function (object, key, defaultValue) {
        return Util.has(object, key) ? object[key] : defaultValue;
    };
    Util.formatString = function (str) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (!str)
            return str;
        return str.replace(/{(\d+)}/g, function (a, b) {
            return args[b];
        });
    };
    Util.htmlEncode = function (str) {
        if (!str)
            return "";
        if ((typeof str) !== "string")
            str = str.toString();
        return str
            .replace(/&/g, '&amp;')
            .replace(/"/g, '&quot;')
            .replace(/'/g, '&#39;')
            .replace(/</g, '&lt;')
            .replace(/>/g, '&gt;')
            .replace(/\//g, '&#x2F;');
    };
    return Util;
}());
exports.Util = Util;


/***/ }),

/***/ "./ImageVault.Symbol/src/DateUtil.ts":
/*!*******************************************!*\
  !*** ./ImageVault.Symbol/src/DateUtil.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.DateUtil = void 0;
var DateUtil = (function () {
    function DateUtil() {
    }
    DateUtil.toJavaScriptDate = function (value) {
        if (!value)
            return null;
        if (typeof value === 'number')
            return new Date(value);
        if (typeof value === 'object')
            return value;
        var pattern = /Date\(([^)]+)\)/;
        var results = pattern.exec(value);
        if (results) {
            return new Date(parseFloat(results[1]));
        }
        var yearMonthDatePattern = /^(\d{4})-(\d{2})-(\d{2})$/;
        var ymdResult = yearMonthDatePattern.exec(value);
        if (ymdResult) {
            return new Date(parseInt(ymdResult[1]), parseInt(ymdResult[2]) - 1, parseInt(ymdResult[3]));
        }
        var isoPattern = /[\+-]\d+:\d+$/;
        if (isoPattern.test(value))
            return new Date(value);
        if (!value.endsWith("Z"))
            value += "Z";
        return new Date(value);
    };
    return DateUtil;
}());
exports.DateUtil = DateUtil;


/***/ }),

/***/ "jquery":
/*!********************!*\
  !*** external "$" ***!
  \********************/
/***/ ((module) => {

"use strict";
module.exports = $;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
var exports = __webpack_exports__;
/*!****************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/exports.ts ***!
  \****************************************************************************************/

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.DateUtil = exports.Editor = exports.Client = void 0;
var imagevault_client_1 = __webpack_require__(/*! ./imagevault-client */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-client.ts");
Object.defineProperty(exports, "Client", ({ enumerable: true, get: function () { return imagevault_client_1.Client; } }));
var editor_1 = __webpack_require__(/*! ./editor */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/editor.ts");
Object.defineProperty(exports, "Editor", ({ enumerable: true, get: function () { return editor_1.Editor; } }));
var DateUtil_1 = __webpack_require__(/*! ../../../../../ImageVault.Symbol/src/DateUtil */ "./ImageVault.Symbol/src/DateUtil.ts");
Object.defineProperty(exports, "DateUtil", ({ enumerable: true, get: function () { return DateUtil_1.DateUtil; } }));

})();

/******/ })()
;
//# sourceMappingURL=imagevault.min.js.map